
unit
  coolmm;

{COOL MEMORY MANAGER by COOL HINST}

{note: now it works}

{note: tasks does not works}

{
DEBUGMM - debug
}

{!!!file saved to UTF - 8}

{$DEFINE DEBUGMM}

{$MODE OBJFPC}
{
  Не собирается с
  Free Pascal dialect
  Object Pascal extension on
  
  собирается с
  Turbo Pascal compatible
  Delphi compatible
}

{
  cahnges:
  
}

interface

const
  const_maxblocks=31;

{GetFirstBlock errors}
  const_GetFirstBlock_err_itisafreeblock=-1;
  const_GetFirstBlock_err_erroneusmap=-2;

{FindTrueBlock errors}
  const_ftb_err_erroneusmap=3;
  const_ftb_err_unknown=4;
  const_ftb_err_badaddr=5;

{getMem errors}
  const_getmemory_err=-1;

{LoadTask results}
  //const_loadtask_ok > 0
  const_loadtask_err_notaskhere=-1;
  const_loadtask_err_notenough=-2;
  const_loadtask_err_cannotrun=-3; //can not run task

  const_address_none=-1;
  const_taskaddr_nomore=-2;

type
  TAddress=longint;
  TMemBlockIndex=longint;

type
  TMemoryElement=record
    state:boolean;
    count:TMemBlockIndex;
  end;

type
  TMemoryMap=array[0..const_maxblocks]of TMemoryElement;

const
  const_registerscount=15;
  const_stacklength=31;

type
  TProcessRegister=type byte;
  TProcessRegisters=type array[0..const_registerscount] of TProcessRegister;

  TStackElement=type byte;
  TProcessStack=type array[0..const_stacklength] of TStackElement;

  TCoolProcess=record
    registers:TProcessRegisters;
    stack:TProcessStack;
    currAddr:TAddress;
  end;
  
  PCoolProcess=^TCoolProcess;

const
  const_maxtasks=63;

type
  TTaskIndex=longint;
  TCoolTasks=array[0..const_maxtasks] of TCoolProcess;

procedure
  InitializeMM(const _memoryblocksize, _memorysize:Taddress);

function
  GetMemory(const _size:TAddress):TAddress;

function
  FreeMemory(const addr:TAddress):boolean;

procedure PrintMemoryState;

{tasks}

type
  TGetTaskRegistersFunc=function:TProcessRegisters;
  TSetTaskRegistersFunc=procedure(const pr:TProcessRegisters);
  TGetTaskStackFunc=function:TProcessStack;
  TSetTaskStackFunc=procedure(const ps:TProcessStack);
  TTaskJumpFunc=function(const addr:TAddress):boolean;
  TTaskGetjFunc=function:TAddress;
  TTaskRunFunc=procedure(const run:boolean);
  
type
  TTaskProcsPack=record
    GetReg:TGetTaskRegistersFunc;
    SetReg:TSetTaskRegistersFunc;
    GetStack:TGetTaskStackFunc;
    SetStack:TSetTaskStackFunc;
    SetJump:TTaskJumpFunc;
    GetJump:TTaskGetjFunc;
    setrun:TTaskRunFunc;
  end;

function
  LoadTask(const _addr:TAddress; const andstart:boolean=false):TTaskIndex;
//загрузить задачу
//andstart:=true, если надо ещё и запустить задачу

procedure InitTaskSwitcher(const mmpp:TTaskProcsPack);
//mmpp - memory manager' procedures pack

function SwitchTask:boolean;

function FreeTask(const i:TTaskIndex; const andfreemem:boolean=false):boolean;

implementation

const
  freeblock=false;
  const_modulename='CoolMM.pas';
  const_modulenamep=const_modulename+' - ';
  const_ActiveTaskNone=-1;

{FindEmptyTaskError}
  const_findemptytask_err_nofreetasks=-1;

{AddTask result}
  {const_AddTask_ok - >=0}
  const_AddTask_err_nofreetasks=-1;

var
  map:TMemoryMap;
  memoryblocksize, memorysize:TAddress;
  bcount:TMemBlockIndex;

  tasksInited:boolean;
  tasks:TCoolTasks;
  taskf:TTaskProcsPack;
  activeTask:TTaskIndex;

{$INCLUDE hfunctions.inc}

procedure WriteDebug(const s:shortstring);
begin
  {$IFDEF DEBUGMM}
  WriteLn(const_modulenamep+s);
  {$ENDIF}
end;

procedure ClearMemoryMap;
var
  i:TMemBlockIndex;
begin
  map[0].state:=not freeblock;
  for i:=1 to bcount-1 do
  begin
    map[i].state:=freeblock;
    map[i].count:=0;
  end;
  map[bcount].state:=not freeblock;
end;

function GetBlockID(const addr:TAddress):TMemBlockIndex;
begin
  GetBlockID:=addr div memoryblocksize;
end;

function BlockIdToAddr(const id:TMemBlockIndex):TAddress;
begin
  BlockIdToAddr:=id*memoryblocksize;
end;

function GetFirstBlock(const id:TMemBlockIndex):TMemBlockIndex;
var
  i,fbi:TMemBlockIndex;
  {fbi - first block index, the result}
begin
  if map[id].state=freeblock then
  begin
    WriteDebug('error: mm.GetFirstBlock - freeblock');
    GetFirstBlock:=const_GetFirstBlock_err_itisafreeblock;
    exit;
  end;
  fbi:=const_GetFirstBlock_err_erroneusmap;
  for i:=id downto 1 do
  begin
    if map[i].count<>0 then
    begin
      fbi:=i;
      break;
    end;
  end;
  GetFirstBlock:=fbi;
end;

function FindTrueBlock(const addr:TAddress):TMemBlockIndex;
var
  id:TMemBlockIndex;
begin
  id:=GetBlockID(addr);
  if map[id].state=freeblock then
  begin
    FindTrueBlock:=id;
  end;
  if not map[id].state=freeblock then
  begin
    id:=GetFirstBlock(id);
    { check id}
    if id<0 then
    begin
      case id of
        const_GetFirstBlock_err_erroneusmap :
        begin
          WriteDebug('error: FindTrueBlock - erroneusmap error');
          FindTrueBlock:=const_ftb_err_erroneusmap;
          exit;
        end;
        else
        begin
          WriteDebug('error: findTrueBlock - unknown error');
          FindTrueBlock:=const_ftb_err_unknown;
          exit;
        end;
      end;
    end;
  end;
  {/check id}
  { check addr}
  if
    (addr<BlockIdToAddr(id))
    or(addr>(BlockIdToAddr(id+map[id].count)))
  then
  begin
    WriteDebug('error: FindTrueBlck - address is out of bounds');
    FindTrueBlock:=const_ftb_err_badaddr;
    exit;
  end;
  {/check addr}
  FindTrueBlock:=id;
end;

procedure
  InitializeMM(const _memoryblocksize, _memorysize:Taddress);
begin
  {call this proc before using COOLMM}
  WriteDebug('Initializing memory manager...');
  memoryblocksize:=_memoryblocksize;
  memorysize:=_memorysize;
  bcount:=memorysize div memoryblocksize;
  WriteDebug('bcount = '+Int2Str(bcount)+
    '//total count of memory blocks');
   ClearMemoryMap;
   tasksInited:=false;
end;

function
  GetMemory(const _size:TAddress):TAddress;
var
  size:TAddress;
  i,ns,c1,c2,cs,b1,b2,bs,ts:TMemBlockIndex;
  fbs:boolean;
begin
  WriteDebug('GetMemory started, _size = '+Int2Str(_size));
  b2:=-1;
  size:=(_size div memoryblocksize) + memoryblocksize;
  WriteDebug('Getmemory.size = '+Int2Str(size));
  ns:=size div memoryblocksize;
  WriteDebug('Getmemory.ns='+Int2Str(ns)+'//needed memory blocks count');
  bs:=bcount;
  ts:=0;
  fbs:=false;
  for i:=0 to bcount do
  begin
    if (map[i].state=freeblock)and(not fbs) then
    begin
      fbs:=true;
      c1:=i;
    end;
    if map[i].state<>freeblock then
    begin
      if fbs then
      begin
        c2:=i;
        cs:=c2-c1;
        fbs:=false;
        if cs=ns then
        begin
          b1:=c1;
          b2:=c2;
          bs:=cs;
          break;
        end;
        if cs>ns then
        begin
          if cs<=bs then
          begin
            b1:=c1;
            b2:=c2;
            bs:=cs;
          end;
        end;
      end;
    end;
    if map[i].state=freeblock then inc(ts);
  end;
  WriteDebug('Getmemory.bs='+Int2Str(bs)+'//best block size');
  if (b2-b1)>=ns then b2:=b1+ns-1;
  WriteDebug('Getmemory - piece of memory : '+Int2Str(b1)+' - '+Int2Str(b2));
  if b2=-1 then
  begin
    GetMemory:=const_getmemory_err;
    WriteDebug('Getmemory.b2='+Int2Str(b2)+'//erroneus b2,exiting');
    exit;
  end;
  for i:=b1 to b2 do
  begin
    map[i].state:=not freeblock;
  end;
  map[b1].count:=b2-b1+1;
  GetMemory:=b1*memoryblocksize;
end;

function
  FreeMemory(const addr:TAddress):boolean;
var
  id,count,i:TMemBlockIndex;
begin
  id:=GetBlockID(addr);
  if map[id].state=freeblock then
  begin
    FreeMemory:=false;
  end
  else
  begin
    id:=FindTrueBlock(addr);
    count:=map[id].count;
    if count=0 then
    begin
      FreeMemory:=false;
      exit;
    end;
    for i:=id to id+count-1 do map[i].state:=freeblock;
    map[id].count:=0;
    FreeMemory:=true;
  end;
end;

procedure PrintMemoryState;
var
  i:TMemBlockIndex;
begin
  for i:=0 to bcount do
  case map[i].state of
    true: Write('X');
    false: Write('0');
  end;
  WriteLn;
end;

{ tasks functions here (v) }

procedure InitTaskSwitcher(const mmpp:TTaskProcsPack);
begin
  taskf:=mmpp;
end;

procedure ClearTasksRecords;
var
  i:TTaskIndex;
begin
  for i:=0 to const_maxtasks do
  begin
    tasks[i].currAddr:=const_address_none;
  end;
end;

procedure InitTasks;
begin
  ClearTasksRecords;
  activeTask:=const_ActiveTaskNone;
end;

function IsEmptyTask(const atask:TCoolProcess):boolean; inline;
begin
  IsEmptyTask:=(atask.currAddr=const_address_none);
end;

function findEmptyTask:TTaskIndex; inline;
var
  i,r:TTaskIndex;
begin
  r:=const_findemptytask_err_nofreetasks;
  for i:=0 to const_maxtasks do
  begin
    if IsEmptyTask(tasks[i]) then
    begin
      r:=i;
    end;
  end;
  findEmptyTask:=r;
end;

procedure saveCurrentTaskTo(const t:PCoolProcess);
begin
  with t^ do
  begin
    t^.currAddr:=taskf.GetJump();
    t^.Registers:=taskf.GetReg();
    t^.stack:=taskf.GetStack();
  end;
end;

procedure saveCurrentTask(const i:TTaskIndex); //i=where
var
  t:PCoolProcess;
begin
  t:=@tasks[i];
  saveCurrentTaskTo(t);
end;

function RestoreSavedTask(const t:PCoolProcess):boolean;
begin
  if IsEmptyTask(t^) then
  begin
    result:=false;
    exit;
  end;
  with t^ do
  begin
    taskf.SetStack(stack);
    taskf.SetReg(registers);
    result:=taskf.SetJump(currAddr)
  end;
end;

function AddTaskToList(const addr:TAddress):longint;
var
  i:TTaskIndex;
begin
  i:=findEmptyTask;
  if i=const_findemptytask_err_nofreetasks then
  begin
    WriteDebug('error: not enough cell for tasks');
    AddTaskToList:=const_AddTask_err_nofreetasks;
    exit;
  end;
  tasks[i].currAddr:=addr;
  AddTaskToList:=i;
end;

procedure MakeNomoretaskList;
var
  i,last:TTaskIndex;
begin
  last:=0;
  for i:=0 to const_maxTasks do
  begin
    if IsEmptyTask(tasks[i]) then
  end;
end;

function isLastTask(const i:TTAskIndex):boolean;
begin
  result:=(tasks[i].currAddr=const_taskaddr_nomore)or (i>=const_maxtasks);
end;

function SwitchToTask(const idx:TTaskIndex):boolean;
begin
  taskf.setrun(false);
  if not (activeTask=const_ActiveTaskNone)
  then
    saveCurrentTask(activeTask);
  result:=RestoreSavedTask(@tasks[idx]);
  taskf.setrun(true);
end;

function LoadTask(const _addr:TAddress;
  const andstart:boolean=false):TTaskIndex;
var
  id:TMemBlockIndex;
  addr:TAddress;
  taskIdx:TTaskIndex;
begin
  if not tasksInited then
  begin
    InitTasks;
  end;
  id:=GetBlockId(_addr);
  if map[id].state=freeblock then
  begin
    WriteDebug('can not LoadTask('+Int2Str(_addr)+') - free block');
    LoadTask:=const_loadtask_err_notaskhere;
    exit;
  end;
  id:=FindTrueBlock(id);
  addr:=BlockIdToAddr(id);
  taskIdx:=AddTaskToList(addr);
  case taskIdx of
    const_AddTask_err_nofreetasks : begin
      WriteDebug('err: LoadTask - no free tasks');
      LoadTask:=const_loadtask_err_notenough;
      exit;
    end;
  end;
  if taskIdx>=0 then
  begin
    WriteDebug('LoadTask - ok');
    result:=taskIdx;
  end;

  MakeNomoretaskList;
  
  if andstart then
  begin
    if switchToTask(taskIdx)
    then
    else
      result:=const_loadtask_err_cannotrun;
  end;
end;

function FreeTask(const i:TTaskIndex; const andfreemem:boolean=false):boolean;
begin
  FreeMemory(tasks[i].currAddr);
  tasks[i].currAddr:=const_address_none;
  MakeNomoretaskList;
end;

function findNextTask(const idx:TTaskIndex):TTaskIndex;
var
  i:TTaskIndex;
begin
  if isEmptyTask(tasks[i]) then
  begin
    findNExtTask:=idx;
    exit;
  end;
  i:=idx;
  repeat
    inc(i);
    if isLastTask(i) then i:=0;
  until not IsEmptyTask(tasks[i])
end;

function SwitchTask:boolean;
begin
  SwitchToTask(findNextTask(activeTask));
end;

end.












