// 
// STIMUL Build  - build_all.pas  -  ver 0.4
// OS Stimul Based on BSD License
//				   http://stimul.freepascal.ru
//				   Target OS : Windows/Linux

Program Build_all;

{$MODE objfpc}

{$APPTYPE CONSOLE}

uses
  Types
  ,Classes
  ,sysUtils
  ,strings
  ,hSimplyConfig
    {important note about hSimplyConfig - you should not
    trim strings, they are already trimmed}
  {$IFDEF WIN32}
    ,dos
  {$ENDIF}
  {$IFDEF LINUX}
    ,unix
  {$ENDIF}
  ;

const
  {$IFDEF WIN32} const_slash='\'; {$ENDIF}
  {$IFDEF LINUX} const_slash='/'; {$ENDIF}
  const_buildlogfn='build.log';

function GetBuildingParams(const aFileName:string;
  var aCompilerPatch:string; var aCompilType:String):boolean;
const
  const_def_fpcbinpatch='FPCPath';
  const_defdefault_fpcbinpatch='C:\pp\bin';
  const_def_comppatch='CompilerPatch';
  const_def_buildtype='Build';
var
  s1,s2:string;
begin
  result:=false;
  if Not FileExists(aFileName) then
  begin
    exit;
  end;
  LoadConfigFile(aFileName);
  s1:= GetDefString(const_def_fpcbinpatch);
  s1:=trim(s1);
  if s1='' then s1:=const_defdefault_fpcbinpatch;
  s2:= GetDefString(const_def_comppatch);
  aCompilerPatch:=s1+const_slash+s2+const_slash;
  aCompilType:=Trim(GetDefString(const_def_buildtype));
  result:=true;//an error was appearing without this line
end;

procedure WriteHr;
var
  i:shortint;
begin
  for i:=1 to 80 do write('-');
  WriteLn;
end;

procedure ClearDirectory(const aDirectory,aMask:string;
  const ar:boolean=false);
var
{$IFDEF WIN32}
  sr:SearchRec;
{$ENDIF}
  dir:string;
  cfn:string; //current filename
begin

{$IFDEF WIN32}
  dir:=ExpandFileName(aDirectory);
  findFirst(dir+const_slash+aMask,faAnyFile,sr);     // Y sr TIP - TSearchRec B LINUX a ne SearchRec!!!
   if DosError<>0 then exit;                      // << NE RABOTAET LINUX DosError TAM BUT NE MOZHET
  repeat
    if (sr.Name='.')or(sr.Name='..') then continue;
    cfn:=dir+const_slash+sr.Name;
    case ((sr.Attr and faDirectory)=sr.Attr) of
    true:
      begin
        if ar then
        begin
          ClearDirectory(cfn,aMask,ar);
        end;
      end;
    false:
      begin
        DeleteFile(cfn);
      end;
    end;
  FindNext(sr);
  until DOSError<>0;
{$ENDIF}

{$IFDEF LINUX}
	FpSystem('/bin/rm -f '+aDirectory+aMask);
{$ENDIF}
end;

var
  patch_comp:String;
	k:longint;
	s:String;    f,r:text; rt:file of byte; _org:LongInt;  s_org:string;
	c:char;  incf:text;  fa,fb:file of byte; ddb:byte; gif:byte; iddb:DWord;
	sm_org:array[0..255] of dword;
  si_org:byte;
  ki_org:byte;
  coni:byte;
  CompType:String;

begin

  SetCurrentDir(ExtractFileDir(ParamStr(0)));

//
// Инициализация 
//

  _org:=$20000;
  si_org:=0;
  sm_org[si_org]:=_org;
  coni:=0;

  if not GetBuildingParams('config.ini',patch_comp,CompType) then
  begin
    WriteLn('Err (1) : can not get build params!');
  end;

 {$IFDEF WIN32}
  WriteLn(' Patch_comp = '+'{'+patch_comp+'}');
 {$ENDIF}
  
// Однако параметр clear / new / old в командной строке важнее, того который в файле, для того чтобы
// скрипт автоматического снепшота работал проще

  if (ParamStr(1))='' then
  else if UpCase(ParamStr(1))='CLEAR' then CompType:='Clear'
  else if UpCase(ParamStr(1))='NEW' then CompType:='New'
  else if UpCase(ParamStr(1))='OLD' then CompType:='Old'
  else Writeln(' Err : udefined type of compile '''+ParamStr(1)+''', will using config.ini - '+CompType);
 
  if CompType<>'Clear' then
  begin
  {$IFDEF LINUX}
        FpSystem('/usr/bin/clear');
  {$ENDIF}
  {$IFDEF WIN32}
        Exec('cls','');
  {$ENDIF}
  end;
	  WriteLn('Stimul Build');
          WriteLn;

  if (CompType='Clear')OR(CompType='New') then
  begin
    Write('Erase binary and temporary files ');
    ClearDirectory('./kernel/services/','*.ppu');
    ClearDirectory('./kernel/services/','*.o');
    ClearDirectory('./kernel/services/','*.ose');
    ClearDirectory('./kernel/services/','*.col');
    ClearDirectory('./kernel/services/','services.inc');
    ClearDirectory('./kernel/services/','*.*~');
    ClearDirectory('./kernel/services/','*.dsk');
    ClearDirectory('./kernel/services/','*.cfg');
    ClearDirectory('./kernel/services/','*.bak');

    ClearDirectory('./','*.o');
    ClearDirectory('./','*.bin');
    ClearDirectory('./','*.ppu');
    ClearDirectory('./','*.a');
    ClearDirectory('./','*.*~');
    ClearDirectory('./','crefs');
    ClearDirectory('./','crefs.exe');
    ClearDirectory('./','stimul*log');
    ClearDirectory('./','build.bat');
    
    ClearDirectory('./','*.img');
    ClearDirectory('./','fp.ini');
    ClearDirectory('./','*.cfg');
    ClearDirectory('./','*.dsk');
    ClearDirectory('./','*.bak');
    ClearDirectory('./','*.pas~');
    ClearDirectory('./kernel/services/','*.bak');
    ClearDirectory('./kernel/services/','*.pas~');

    WriteLn('       ... Ok');
  end;

if (CompType<>'Clear') then
begin
  Writeln;
  WriteLn('Compiling Services');

  // WriteLn('Reading services list (./kernel/services/list.inc)...');
  assignFile(f,'.'+const_slash+'kernel'+const_slash+'services'
    +const_slash+'list.inc');
  try
    reset(f);
  except
    WriteLn('File not found!... step aborted, press Enter for next step');
    readln;
  end;
  while not eof(f) do
  begin
    readln(f,s);
    if pos(';',s)=1 then continue; //
    WriteLn('Compiling "'+s+'"');
    {$IFDEF WIN32}
      WriteHr;
      if not FileExists(patch_comp+'fpc.exe') then
      begin
        WriteLN('file "'+patch_comp+'fpc.exe'+'" does not exists, exiting...');
        exit;
      end;
      Exec(patch_comp+'fpc.exe','-RIntel -Us -ve .\kernel\services\'+s+'.pas');
      //{h}Exec(patch_comp+'fpc.exe','.\kernel\services\'+s+'.pas');
      WriteHr;
    {$ENDIF}
    {$IFDEF LINUX}
      WriteLn('Compiling : /usr/bin/fpc -Rintel -Us -v0 -Fokernel/services ./kernel/services/'+s+'.pas');
      fpSystem('/usr/bin/fpc -Rintel -Us -v0 -Fokernel/services ./kernel/services/'+s+'.pas');
    {$ENDIF}
      str(_org,s_org);
    {$IFDEF WIN32}
      Exec(patch_comp+'ld.exe','-e '+s_org+' -b ihex .\kernel\services\'+s+'.o -o .\kernel\services\'+s+'.ose');
    {$ENDIF}
    {$IFDEF LINUX}
      WriteLn('Linking : /usr/bin/ld -s -e '+s_org+' -b ihex ./kernel/services/'+s+'.o -o ./kernel/services/'+s+'.ose');
      FpSystem('/usr/bin/ld --no-warn-mismatch -s -e '+s_org+' -b ihex ./kernel/services/'+s+'.o -o ./kernel/services/'+s+'.ose');
      WriteLn('Done');
    {$ENDIF}
    assign(rt,'./kernel/services/'+s+'.o');   {ose ???}
    try
      reset(rt);
    except
      WriteLn('Err: file not found "'+'./kernel/services/'+s+'.ose"'
        +' FATAL, PANIC, EXITING...');
      ReadLN;
      exit;
    end;
    _org:=_org+FileSize(rt);
    close(rt);
    inc(si_org);
    sm_org[si_org]:=_org;
  end;
  close(f);

//

  ki_org:=0;
  WriteLn;

  if CompType='New' then
  begin
    WriteLn('Reading services list (/kernel/services/list.inc)...          ');
    assign(f,'./kernel/services/list.inc');
    writeln;
    {$I-}
    reset(f); if (IOResult<>0) then begin WriteLn; WriteLn('File not found!... step aborted, press Enter for next step'); readln; exit; end;
    {$I+}
    readln(f);
    readln(f);      readln(f);
    assign(incf,'./kernel/services/services.inc');
    rewrite(incf);
    WriteLn(incf,';This file was generated automaticaly in processing STIMUL build, please don''t edit it, if you don''t understand what you make');
    WriteLn(incf,';Thank you (C) STIMUL - BSD Based License');
    WriteLn(incf);
    assign(fb,'./kernel/services/services.col');
    rewrite(fb);
    while not eof(f) do
    begin
      readln(f,s);
      {$I-}
      WriteLn('Try open '+s+'.o');
      assign(fa,'./kernel/services/'+s+'.o'); {ose !!! ????}
      reset(fa);
      if (IOResult<>0) then begin WriteLn; WriteLn('File ./kernel/services/'+s+'.ose not found!, but declared...'); WriteLn(' Compilation aborted...'); exit; end;
      {$I+}
      gif:=0;
      iddb:=0;
      while not eof(fa) do
      begin
        read(fa,ddb);
        if (gif=0) and (ddb=$0) then  gif:=gif+1
        else if (gif=1) and (ddb=$ff) then gif:=gif+1
        else if (gif=2) and (ddb=$0f) then gif:=gif+1
        else if (gif=3) and (ddb=$fa) then gif:=gif+1
        else if (gif=4) and (ddb=$f0) then gif:=gif+1
        else if (gif=5) and (ddb=$af) then gif:=gif+1
        else if (gif=6) and (ddb=$aa) then gif:=gif+1
        else gif:=0;

          if (gif=7) then begin
				WriteLn('  - Entry Point ',S,' at ',iddb);
				WriteLn(incf,s+' equ ',(sm_org[ki_org]+iddb+1-$20000));
			  end;

        write(fb,ddb);
        inc(iddb);
      end;
      close(fa);
      WriteLn(s+'  [ Done ]');
      Writeln;
      inc(ki_org);
    end;
    close(f);
    close(fb);
    close(incf);
    WriteLn('Complite');
  end
  else
  begin
    WriteLn('Old services was keeped');
  end;
  WriteLn;

  {$IFDEF WIN32}
    WriteHR;
    Exec('.\fasm\fasm.exe','a.asm');          // 
    Exec('.\fasm\fasm.exe','setup.asm');      // 
    Exec('.\fasm\fasm.exe','kernel.asm');     // 
    WriteHR;
  {$ENDIF}

  {$IFDEF LINUX}
    Writeln('Assembling Kernel');
    fpSystem('./fasm/fasm a.asm');
    fpSystem('./fasm/fasm setup.asm');
    fpSystem('./fasm/fasm kernel.asm');
  {$ENDIF}

// 
 {$IFDEF WIN32}
	Exec(patch_comp+'fpc.exe','crefs.pas');
  {	Exec('crefs.exe','');   }
  {$ENDIF}

  {$IFDEF LINUX}
    fpSystem('/usr/bin/fpc -v0 crefs.pas');
    fpSystem('./crefs');
  {$ENDIF}

// 
// Настройка для запуска на целевой системе 
//

  {$IFDEF WIN32}
    Assign(fstart,'build.bat');
    Rewrite(fstart);
    Writeln(fstart,'crefs');
    Writeln(fstart,'copy /b a.bin+setup.bin X.img');
    Write(fstart,'copy /b X.img+b.img+c.img+d.img+kernel.bin+.\kernel\services\services.col a.img');
    Close(fstart);
    Exec('build.bat','');
    ClearDirectory('./','build.bat');
  {$ENDIF}

  {$IFDEF LINUX}
    fpSystem('/bin/cat a.bin > X.img');
    fpSystem('/bin/cat setup.bin >> X.img');
    fpSystem('/bin/cat X.img > a.img');
    fpSystem('/bin/cat b.img >> a.img');
    fpSystem('/bin/cat c.img >> a.img');
    fpSystem('/bin/cat d.img >> a.img');
    fpSystem('/bin/cat kernel.bin >> a.img');
    fpSystem('/bin/cat ./kernel/services/services.col >> a.img');
    fpSystem('/bin/chmod -fR 775 *');		//
  {$ENDIF}
    ClearDirectory('./','X.img');
    ClearDirectory('./','b.img');
    ClearDirectory('./','c.img');
    ClearDirectory('./','d.img');

  WriteLn;
end;//end of compiling services
  WriteLn('All Done (if not errors, of course)');
  {$IFDEF WIN32} readln; {$ENDIF}
end.
