unit hSimplyConfig;

interface

{$mode objfpc}

procedure LoadConfigFile(const aFileName:string);
function GetDefString(const aKey:string):string; inline;

implementation

type
  TDefStr=array[0..1] of string;
  
const
  const_ds_key=0;
  const_ds_value=1;
  const_maxdefs=100;

var
  defs:array[1..const_maxdefs] of TDefStr;
  defcount:integer;
  
function htrim(const s:string):string;
var
  ss:string;
begin
  ss:=s;
  while pos(' ',ss)=1 do delete(ss,1,1);
  while ss[length(ss)]=' ' do delete(ss,length(ss),1);
  result:=ss;
end;

procedure LoadConfigFile(const aFileName:string);
var
  i:integer;
  t:text;
  s,skey:string;
begin
  i:=0;
  assignFile(t,aFileName);
  reset(t);
  while not eof(t) do
  begin
    ReadLN(t,s);
    s:=htrim(s);
    if pos('#',s)=1 then continue;
    if length(s)=0 then continue;
    skey:=copy(s,1,pos('=',s)-1);
    skey:=htrim(skey);
    delete(s,1,pos('=',s));
    s:=htrim(s);
    inc(i);
    defs[i,const_ds_key]:=skey;
    defs[i,const_ds_value]:=s;
    if i>=const_maxdefs then break;
  end;
  defcount:=i;
  closeFile(t);
end;

function GetDefString(const aKey:string):string;
var
  i:integer;
begin
  result:='<none>';
  for i:=1 to defcount do
  begin
    if aKey=defs[i,const_ds_key] then
    begin
      result:=defs[i,const_ds_value];
      break;
    end;
  end;
end;

end.
