
;
; Unit for ATA Interface
;

;     
; ( "")
MaxHDDWaitTime equ 1000
SectorDataBuffer EQU 5f0000h ;DB 512 DUP (?)

;*************************************************
;*        LBA   *
;*      *
;* :                                    *
;* ChannelNumber -   (1 - 4);         *
;* HDDNumber -     (0  1);  *
;* SectorAddress -   .   *
;*     ,   *
;*   SectorDataBuffer.                    *
;*************************************************
ReadHDDSector:
	pushad
;   LBA
	mov	[ATAAddressMode],1
;     ( )
	mov	[ATAFeatures],0
	mov	[ATASectorCount],1
	mov	EAX,[SectorAddress]
	mov	dword [ATASectorNumber],EAX
	mov	[ATACommand],20h
	call	SendCommandToHDD
	cmp	[HDDErrorCode],0
	jne	@@End	 ;,   
;    HDD
	mov	DX,[HDDBasePortAddr]
	add	DX,7	 ;  
@@WaitCompleet:
	;    
	inc	[HDDTime]
	mov	EAX,[HDDTime]
	cmp	EAX,MaxHDDWaitTime
	ja	@@Error1 ; -
	;  
	in	AL,DX
	test	AL,80h	 ;  BSY
	jnz	@@WaitCompleet
	test	AL,08h	 ;  DRQ
	jz	@@WaitCompleet
;  
	mov	EDI,SectorDataBuffer	    ; OOOFSET
	mov	DX,[HDDBasePortAddr] ; 
	mov	CX,256	 ;  
	rep	insw	 ;  
;   
	mov	[HDDErrorCode],0
	jmp	@@End
;   
@@Error1:
	mov	[HDDErrorCode],1 ; -
	jmp	@@End
@@End:
	popad
	ret


;****************************************************
;*                      *
;*         *
;* :                                       *
;* ChannelNumber -   (1 - 4);            *
;* HDDNumber -   (0  1);               *
;* ATAFeatures - "";                     *
;* ATASectorCount -  ;            *
;* ATASectorNumber -   ;      *
;* ATACylinder -   ;         *
;* ATAHead -   ;               *
;* ATAAddressMode -   (0-CHS, 1-LBA); *
;* ATACommand -  .                        *
;*    :              *
;*  SectorDataBuffer -  ;         *
;*  HDDBasePortAddr -   HDD;           *
;*  HDDTime -    ;    *
;*  HDDErrorCode - .                           *
;*     HDDErrorCode     *
;*   .                            *
;****************************************************
SendCommandToHDD:
	pushad
;      
	;   ES   BIOS
	;   
	mov	[HDDTime],0
;    
	cmp	[ATAAddressMode],1
	ja	@@Error02
;    
	mov	BX,[ChannelNumber]
	cmp	BX,1
	jb	@@Error03
	cmp	BX,4
	ja	@@Error03
;   
	dec	EBX			     ;       !
	shl	EBX,1
	mov	AX,[EBX+StandardHDDBases]
	mov	[HDDBasePortAddr],AX
;     HDD
	mov	DX,[HDDBasePortAddr]
	add	DX,206h
	mov	AL,1010b
	out	DX,AL

;  "" HDD
	mov	DX,[HDDBasePortAddr]
	add	DX,7	 ;  
@@WaitNotBSY:
	;    
	inc	[HDDTime]
	mov	EAX,[HDDTime]
	cmp	EAX,MaxHDDWaitTime
	ja	@@Error01 ; -
	;    BSY
	in	AL,DX
	test	AL,80h	 ;  BSY
	jnz	@@WaitNotBSY

;   HDD   
	;   
	mov	DX,[HDDBasePortAddr]
	add	DX,6	;  
	mov	AL,[HDDNumber]
	cmp	AL,1	;  
	ja	@@Error04
	shl	AL,4
	or	AL,10100000b
	out	DX,AL
	; ,     
	inc	DX
@@WaitHDReady:
	;    

	inc	[HDDTime]
	mov	EAX,[HDDTime]
	cmp	EAX,MaxHDDWaitTime
	ja	@@Error01 ; -
	;   BSY  DRDY
	in	AL,DX
	test	AL,80h	 ;  BSY
	jnz	@@WaitHDReady
	test	AL,40h	 ;  DRDY
	jz	@@WaitHDReady

;     
	mov	DX,[HDDBasePortAddr]
	inc	DX	 ; ""
	mov	AL,[ATAFeatures]
	out	DX,AL
	inc	DX	 ; 
	mov	AL,[ATASectorCount]
	out	DX,AL
	inc	DX	 ;  
	mov	AL,[ATASectorNumber]
	out	DX,AL
	inc	DX	 ;  ( )
	mov	AX,[ATACylinder]
	out	DX,AL
	inc	DX	 ;  ( )
	mov	AL,AH
	out	DX,AL
	inc	DX	 ; / 
	mov	AL,[HDDNumber]
	shl	AL,4
	cmp	[ATAHead],0Fh  ;  
	ja	@@Error05
	or	AL,[ATAHead]
	or	AL,10100000b
	mov	AH,[ATAAddressMode]
	shl	AH,6
	or	AL,AH
	out	DX,AL
;  
	mov	AL,[ATACommand]
	inc	DX	 ; 
	out	DX,AL
;   
	mov	[HDDErrorCode],0
	jmp	@@End0

;   
@@Error01:
	mov	[HDDErrorCode],1
	jmp  @@End0
@@Error02:
	mov	[HDDErrorCode],2
	jmp  @@End0
@@Error03:
	mov	[HDDErrorCode],3
	jmp @@End0
@@Error04:
	mov	[HDDErrorCode],4
	jmp  @@End0
@@Error05:
	mov	[HDDErrorCode],5
	jmp  @@End0
@@End0:
	popad
	ret


;*************************************************
;*              *
;*      *
;* :                                    *
;* ChannelNumber -   (1 - 4);         *
;* HDDNumber -     (0  1).  *
;*         *
;*   SectorDataBuffer.                    *
;*************************************************
ReadHDD_ID:
	pushad
;   CHS
	mov	[ATAAddressMode],0
;    
	mov	[ATAFeatures],0
	mov	[ATAHead],0
	mov	[ATACommand],0ECh
	call	SendCommandToHDD
	cmp	[HDDErrorCode],0 ;  
	jne	@@End  ;,   
;    HDD
	mov	AX,0
	mov	ES,AX
	mov	DX,[HDDBasePortAddr]
	add	DX,7	 ;  
@@WaitCompleet1:
	;    
	inc	[HDDTime]
	mov	EAX,[HDDTime]
	cmp	EAX,MaxHDDWaitTime
	ja	@@Error10 ; -
	;  
	in	AL,DX
	test	AL,80h	 ;  BSY
	jnz	@@WaitCompleet1
	test	AL,1	 ;  ERR
	jnz	@@Error60
	test	AL,08h	 ;  DRQ
	jz	@@WaitCompleet1
;     
	mov	EDI,SectorDataBuffer
	mov	DX,[HDDBasePortAddr] ; 
	mov	CX,256	 ;  
	rep	insw	 ;  
	jmp @@End1
;   
@@Error10:
	mov	[HDDErrorCode],1
	jmp  @@End1
@@Error60:
	mov	[HDDErrorCode],6
@@End1:
	popad
	ret

IDEContrRegsBaseAddr DW ?



;    PRD
PRD_Table : DB 1024 DUP(?)


;     1 - 4
StandardHDDBases DW 1F0h, 170h, 1E8h, 168h
;  
ChannelNumber DW ?
;      HDD
HDDBasePortAddr DW ?
;  
HDDNumber DB ?
;  ATA-
ATAFeatures	DB ? ;
ATASectorCount	DB ? ;  
ATASectorNumber DB ? ;  
ATACylinder	DW ? ;  
ATAHead 	DB ? ;  
ATAAddressMode	DB ? ;  (0 - CHS, 1 - LBA)
ATACommand	DB ? ; ,  
;   (0 -  , 1 -  
;  , 2 -    ,
; 3 -   , 4 -   ,
; 5 -   , 6 -   
; )
HDDErrorCode DB 0
;      
HDDTime DD ?
;      LBA
SectorAddress DD 0
;      
