//convideo_util.pas
{
  utils for console system bios video
}

{$undef hyperfresh}

type
  TsmVideoCell=record
    ch:char;
    at:byte;
  end;

  TsmVideoMem=array[0..const_smc_screenwidth,0..const_smc_screenheight]of TsmVideoCell;
  PsmVideoMem=^TsmVideoMem;

  TsmVideoCaret=record 
    x,y:byte; 
    color:byte;
  end;

  TsmvuOnNewStr=procedure;

var
  smvu_conmem:TsmVideoMem;
  smvu_caret:TsmVideoCaret;
  smvu_realcaret:^word;
  smvu_realtxtattr:^byte;
  smvu_stateStr:TShortString;
  smvu_ClearOnNewLine:boolean;
  smvu_scrollvalue:^byte;

const
  const_smvu_normatt=const_smc_defaultTextAttr;

function smvu_init:boolean;
const
  const_stst:string='State string'#0;
begin
  smvu_realcaret:=pointer($50);
  smvu_realtxtattr:=pointer($52);
  smvu_stateStr:=sstr_create(@const_stst);
  smvu_ClearOnNewLine:=false;
  smvu_scrollvalue:=nil;
  result:=true;
end;

function smvu_checkpos(const x,y:byte):boolean;
begin
  exit(
    (0<x)and
    (0<y)and
    (x<=const_smc_screenwidth)and
    (y<=const_smc_screenheight)
  );
end;

function smvu_set(const x,y:byte; const ach:char):boolean;
begin
  result:=smvu_checkpos(x,y);
  if not result then exit;
  smvu_conmem[x,y].ch:=ach;
end;

function smvu_set(const x,y:byte; const ach:char; const att:byte):boolean;
begin
  result:=smvu_checkpos(x,y);
  if not result then exit;
  smvu_conmem[x,y].ch:=ach;
  smvu_conmem[x,y].at:=att;
end;

function smvu_get(const x,y:byte):char;
begin
  if not smvu_checkpos(x,y) then exit(' ');
  result:=smvu_conmem[x,y].ch;
end;

function smvu_att(const x,y:byte):byte;
begin
  if not smvu_checkpos(x,y) then exit($0F);
  result:=smvu_conmem[x,y].at;
end;

function smvu_set(const ac:TsmVideoCaret; const ach:char):boolean;
begin
  result:=smvu_set(ac.x,ac.y,ach,ac.color);
end;

function smvu_cll(const x,y:byte):TsmVideoCell;
begin
  result.ch:=' ';
  result.at:=const_smvu_normatt;
  if not smvu_checkpos(x,y) then exit;
  result:=smvu_conmem[x,y];
end;

function smvu_cls(const x,y:byte; const acll:TsmVideoCell):boolean;
begin
  result:=smvu_checkpos(x,y);
  if not result then exit;
  smvu_conmem[x,y]:=acll;
end;

procedure smvu_beforeRefresh;
begin
  smvu_conmem[80,1].ch:='*';
end;

procedure smvu_after_refresh;
  procedure echoStst;
  var
    s:TShortString;
  begin
    s:=smvu_stateStr;
    s:='['+IntToShortStr(smvu_caret.x)+'|'+IntToShortStr(smvu_caret.y)+']'+s;
    if s.len>const_smc_screenwidth
    then s.len:=const_smc_screenwidth;
    sstr_echo(s); 
  end;
begin
  echoStst;
end;

procedure smvu_refresh;
var
  x,y:byte;
begin
  smvu_beforeRefresh;
  smvu_realcaret^:=0;
  y:=1;
  while y<=const_smc_screenheight do
  begin
    x:=1;
    while x<=const_smc_screenwidth do
    begin
      smvu_realtxtattr^:=smvu_att(x,y);
      WriteChar(smvu_get(x,y));
      //WriteChar('+');
      inc(x);
    end;
    inc(y);
  end;
  if smvu_stateStr.len>const_smc_screenwidth 
    then smvu_stateStr.len:=const_smc_screenwidth;
  smvu_after_refresh;
  smvu_realCaret^:=0;
end;

procedure smvu_ClearLine(const ay:byte=0);
var
  x,y:byte;
begin
  x:=1;
  y:=ay;
  if y=0 then y:=smvu_caret.y;
  while x<=const_smc_screenwidth do
  begin
    smvu_set(x,y,' ',const_smc_defaultTextAttr);
    inc(x);
  end;
end;

procedure smvu_scroll;
var
  x,y:byte;
begin
  y:=1;
  while y<=const_smc_screenheight-1 do
  begin
    x:=1;
    while x<=const_smc_screenwidth do 
    begin
      smvu_cls(x,y,smvu_cll(x,y+1));
      inc(x);
    end;   
    inc(y);
  end;
  x:=1;
  while x<=const_smc_screenwidth do
  begin
    smvu_set(x,const_smc_screenheight,' ',const_smvu_normatt);
    inc(x);
  end;
  smvu_refresh;
  if smvu_scrollvalue<>nil then dec(smvu_scrollvalue^);
end;

procedure smvu_clear;
var
  x,y:byte;
begin
  x:=1;
  while x<=const_smc_screenwidth do
  begin
    y:=1;
    while y<=const_smc_screenwidth do
    begin
      {
      smvu_conmem[x,y].ch:=' ';
      smvu_conmem[x,y].at:=const_smvu_normatt;
      }
      smvu_set(x,y,' ',const_smvu_normatt);
      inc(y);
    end;
    inc(x);
  end;
  smvu_refresh;
  smvu_caret.x:=1;
  smvu_caret.y:=1;
  smvu_caret.color:=const_smvu_normatt;
end;

procedure smvu_goCaret;
begin
  inc(smvu_caret.x);
  if smvu_caret.x>const_smc_screenwidth then
  begin
    inc(smvu_caret.y);
    smvu_caret.x:=1;
    if smvu_ClearOnNewLine then smvu_ClearLine;
  end;
  if smvu_caret.y>const_smc_screenheight then
  begin
    smvu_scroll;
    smvu_caret.y:=const_smc_screenheight;
  end;
end;

procedure smvu_write(const ach:char);
begin
  smvu_set(smvu_caret,ach);
  smvu_goCaret;
  {$ifdef hyperfresh}
    smvu_refresh;
  {$endif}
  //WriteChar('_');WriteChar('_');WriteChar('_');
end;

function smvu_write(const s:TShortString):boolean;
var
  i:longint;
begin
  if s.len=0 then exit(false);
  i:=1;
  while i<=s.len do
  begin
    smvu_write(s.st[i]);
    inc(i);
  end;
  result:=true;
  smvu_refresh;
end;

procedure smvu_backline(const ay:byte=0);
begin
  smvu_caret.x:=1;
  if ay<>0 then smvu_caret.y:=ay;
end;

procedure smvu_typenter;
begin
  smvu_caret.x:=1;
  inc(smvu_caret.y);
  smvu_ClearLine;
  if smvu_caret.y>const_smc_screenheight then
  begin
    smvu_scroll;
    smvu_caret.y:=const_smc_screenheight;
  end;  
end;


function smvu_writeLn(const s:TShortString):boolean;
begin
  result:=smvu_write(s);
  smvu_typenter;
end;

{$undef hyperfresh}






