{$ifdef hunit}

unit
  coolmm;

{$define hface}

{$endif}

//Memory Manager "CoolMemoryManaer", "The CoolMM" by hinst

//::defines description::
{
hface - if defined, you can use it as "include" file in interface section
hunit - if defined, you can use it as unit
hswdbg - write debug messages, for realos mode
}

{file saved to UTF8}

//{$ifdef hswdbg} as {$endif}

{$ifdef hall}
  {$define hface}
{$endif}

{$ifdef hunit}

interface

{$endif}

{$ifdef hface}


const
  const_first_page=$600000;  // Мда... HEX надо hinst)

 // const_maxblocks=1; {count of memory blocks, that will be reserved}

 // Карта памяти храниться по постоянному адресу 111000h, не надо создавать никаких бешенных массивов



{FindTrueBlock errors}
  const_ftb_err_erroneusmap=3; {first block not found}
  const_ftb_err_unknown=4; {unknown error}
  const_ftb_err_badaddr=5; {addr is out of bounds}

{getMem errors}
  const_getmemory_err=-1; {can not get memory for some reason}

{LoadTask results}
  //const_loadtask_ok > 0
  const_loadtask_err_notaskhere=-1; {the block at specified address
    does not contains code}
  const_loadtask_err_notenough=-2; {there is not enough records to 
      save an additional}
  const_loadtask_err_cannotrun=-3; {can not run task - the specified proc
    for task running returned false}

  const_address_none=-1; {empty address}
  const_taskaddr_nomore=-2; {X3}

type
  int=longint; {integer}

  TAddress=longint; {Address}
  TMemBlockIndex=longint; {MemBlockIndex}

//type
//  TMemoryElement=record //a memory block
 //   state:boolean; {true = busy, false = free}
//    count:TMemBlockIndex; {количество блоков после этого, 
 //     являющихся частями одного куска}
//  end;

//type
//  TMemoryMap=array[0..const_maxblocks]of TMemoryElement; {memory map}

const
  const_registerscount=15; {count of registers??}
  const_stacklength=31; {length of stack?}

type
  TProcessRegister=type byte; {an process register}
  TProcessRegisters=type array[0..const_registerscount] of TProcessRegister; {
    process registers}

  TStackElement=type byte; {an process stack element}
  TProcessStack=type array[0..const_stacklength] of TStackElement;{
    process stack}

  TCoolProcess=record {a single process storage}
    registers:TProcessRegisters;  {process's saved registers}
    stack:TProcessStack; {process's saved stack}
    currAddr:TAddress; {execution stopped at this address}
  end;
  
  PCoolProcess=^TCoolProcess; {a pointer to process storage}

const
  const_maxtasks=63; {maximum count of taksks}

type
  TTaskIndex=longint; {task index}
  TCoolTasks=array[0..const_maxtasks] of TCoolProcess; {tasks storage}
  
{$ifdef hall}{$else}

procedure
  InitializeMM(const _memoryblocksize, _memorysize:Taddress); {call
    this proc before using memory manager's funcstions}

function
  GetMemory(const _size:TAddress):TAddress; {reserves memory of specified size, 
    if fails - returns errorcode}

function
  FreeMemory(const addr:TAddress):boolean; {frees memory at specified address,
    if fails - returns false}

procedure PrintMemoryState; {prints memory state to screen}

{$endif}

{tasks}

type
  TGetTaskRegistersFunc=function:TProcessRegisters; {returns
    current registers, that uses current task - needed to store
    registers to storage}
  TSetTaskRegistersFunc=procedure(const pr:TProcessRegisters); {sets
    stored registers to real registers}
  TGetTaskStackFunc=function:TProcessStack; {returns current stack
    ;needed to save process stack to process storage}
  TSetTaskStackFunc=procedure(const ps:TProcessStack); {то же,
    что предыдущее, но в обратную сторону}
  TTaskJumpFunc=function(const addr:TAddress):boolean; {start to 
    execute code in memory at specified address}
  TTaskGetjFunc=function:TAddress; {returns current code executing
    address}
  TTaskRunFunc=procedure(const run:boolean);
  
type
  TTaskProcsPack=record {main procs storage}
    GetReg:TGetTaskRegistersFunc;
    SetReg:TSetTaskRegistersFunc;
    GetStack:TGetTaskStackFunc;
    SetStack:TSetTaskStackFunc;
    SetJump:TTaskJumpFunc;
    GetJump:TTaskGetjFunc;
    setrun:TTaskRunFunc;
  end;

{$ifdef hall}{$else}

function
  LoadTask(const _addr:TAddress; const andstart:boolean=false):TTaskIndex; {
    loads task at the specified address,
    if andstart=true, switchs to it immediately}

procedure InitTaskSwitcher(const mmpp:TTaskProcsPack); {mmpp - 
  memory manager' procedures pack; call this function before using
  task switcher's functions}

function SwitchTask:boolean; {call this function when need to 
  switch task to the next task}

function FreeTask(const i:TTaskIndex; const andfreemem:boolean=false):boolean;
  {frees task at specified index}
  
{$endif}

{$endif}

{$ifdef hunit}
implementation
{$undef hface}
{$endif}

{$ifdef hall}
  {$undef hface}
{$endif}

{$ifdef hface}{$else}

const
  freeblock=false;
  const_modulename='CoolMM.pas'; //my name is const_modulename
  const_modulenamep=const_modulename+' - ';
  const_ActiveTaskNone=-1; {no tasks are active now}

{GetFirstBlock errors}
  const_GetFirstBlock_err_itisafreeblock=-1; {an error code 
    - first block of task is empty}
  const_GetFirstBlock_err_erroneusmap=-2; {the memory map 
    is erroneus - occures when there is no first block for current
    memory piece}

{FindEmptyTaskError}
  const_findemptytask_err_nofreetasks=-1; {there is no empty 
    task storages to place a new task}

{AddTask result}
  {const_AddTask_ok - >=0}
  const_AddTask_err_nofreetasks=-1;
//
var
 // map:TMemoryMap;
  memoryblocksize, memorysize:LongInt;
  bcount:LongInt;

  tasksInited:boolean; //is task switcher initialized?
  tasks:TCoolTasks;
  taskf:TTaskProcsPack;
  activeTask:TTaskIndex;

{$define hswdbg} {debug in "hard" mode}



procedure WriteDebug(const s:shortstring); {noos-mode write function}
begin
  {$ifdef hunit}
  WriteLn(const_modulenamep+s);
  {$endif}
end;

procedure SaveMap(num:longint; state:byte; count:longint);	// Сохраняет в RAM положение страницы памяти num
var
	p_offset:longint;
	m1:byte; m2:longint;
begin
	p_offset:=num*5;
	m1:=state;
	m2:=count;
	asm
		mov	eax,$111000
		add	eax,p_offset
		mov	bl,m1
		mov	byte ptr [eax],bl
		inc	eax
		mov	ebx,m2
		mov	dword ptr [eax],ebx
	end;
end;

procedure LoadMap(num:longint; var state:byte; var count:longint);
var
	p_offset:longint;
        m1:byte; m2:longint;
begin
	p_offset:=num*5;
	asm
		mov	eax,$111000
		add	eax,p_offset
		mov	bl,byte ptr [eax]
		mov	m1,bl
		inc	eax
		mov	ebx,dword ptr [eax]
		mov	m2,ebx
	end;
	state:=m1;
	count:=m2;
end;

function GetState_mem(id:longint):byte;
var
   st:byte;
   c:longint;
begin
	LoadMap(id,st,c);
	GetState_mem:=st;
end;

function GetCount_mem(id:longint):longint;
var
   st:byte;
   c:longint;
begin
	LoadMap(id,st,c);
	GetCount_mem:=c;
end;

procedure ClearMemoryMap; {clear all memory blocks state}
var
  i:LongInt;
begin
  SaveMap(0,0,0);
  i:=1;				// Hinst! не применяй цикл for (!!!) его оптимизация дает глюка на этом куске, например, так что процедура SaveMap вызывается 1 раз всего
  while i<bcount do
  begin
    SaveMap(i,0,0);
    inc(i);
  end;
end;

function GetBlockID(const addr:TAddress):TMemBlockIndex; {get
  bock index at specified address}
begin
  GetBlockID:=addr div memoryblocksize;
end;

function BlockIdToAddr(const id:TMemBlockIndex):TAddress; {get
  address of the begining of the specified block}
begin
  BlockIdToAddr:=id*memoryblocksize;
end;

function GetFirstBlock(const id:TMemBlockIndex):TMemBlockIndex; {get 
  first block of specified memory piece}
var
  i,fbi:TMemBlockIndex;
  {fbi - first block index, the result}
begin
  if GetState_mem(id)=0 then
  begin
    GetFirstBlock:=const_GetFirstBlock_err_itisafreeblock;
    exit;
  end;
  fbi:=const_GetFirstBlock_err_erroneusmap;
  for i:=id downto 1 do
  begin
   if GetCount_Mem(id)<>0 then
    begin
      fbi:=i;
      break;
    end;
  end;
  GetFirstBlock:=fbi;
end;

function FindTrueBlock(const addr:TAddress):TMemBlockIndex; {get
  first block of specified memory piece}
var
  id:TMemBlockIndex;
begin
  id:=GetBlockID(addr);
  if GetState_mem(id)=0 then
  begin
    FindTrueBlock:=id;
  end;
  if not (GetState_mem(id)=0) then
  begin
    id:=GetFirstBlock(id);
    { check id}
    if id<0 then
    begin
      case id of
        const_GetFirstBlock_err_erroneusmap :
        begin
          {$ifdef writedbg}
            WriteDebug('error: FindTrueBlock - erroneusmap error');
          {$endif}
          FindTrueBlock:=const_ftb_err_erroneusmap;
          exit;
        end;
        else
        begin
          {$ifdef writedbg}
            WriteDebug('error: findTrueBlock - unknown error');
          {$endif}
          FindTrueBlock:=const_ftb_err_unknown;
          exit;
        end;
      end;
    end;
  end;
  {/check id}
  { check addr}
  if
    (addr<BlockIdToAddr(id))
    or(addr>(BlockIdToAddr(id+GetCount_mem(id))))
  then
  begin
    {$ifdef writedbg}
      WriteDebug('error: FindTrueBlck - address is out of bounds');
    {$endif}
    FindTrueBlock:=const_ftb_err_badaddr;
    exit;
  end;
  {/check addr}
  FindTrueBlock:=id;
end;

procedure
  InitializeMM(const _memoryblocksize, _memorysize:Taddress);
begin
 (* WriteChar('H');
  {call this proc before using COOLMM}
  //bI
  {$ifdef hswdbg}
    
    WriteHStringLn('Intializing memory man...'#0);
    WriteChar('b');WriteChar('=');
    WriteHString(IntToShortStr(_memoryblocksize));
    WriteChar(',');WriteChar('a');WriteChar('=');
    WriteHString(IntToShortStr(_memorysize));
  {$endif}
  
  memoryblocksize:=_memoryblocksize;
  memorysize:=_memorysize;
  
  bcount:=memorysize div memoryblocksize;
  {$ifdef hswdbg}
    WriteChar(',');WriteChar('c');WriteChar('=');
 //   WriteHString(IntToShortStr(bcount));
  {$endif}
  ClearMemoryMap;
  tasksInited:=false;
  
 // WriteHstringLn;*)


  memoryblocksize:=_memoryblocksize;
  memorysize:=_memorysize;
  bcount:=memorysize div memoryblocksize;

  ClearMemoryMap;
  tasksInited:=false;

  // Выводим информацию о результате инициализации

  Write_CString(@Init_info_1); Write_ln;
  Write_CString(@Init_info_2); Write_UINT(memorysize); Write_CString(@init_bytes); Write_ln;
  Write_CString(@Init_info_3); PutHexI(const_first_page); WriteChar('h'); Write_ln;
  Write_CString(@Init_info_4); Write_UINT(bcount); Write_Ln;

end;

function GetMemory_reladdr(const _size:TAddress):TAddress;
  {$ifdef hswdbg}
    {$define sdme}
  {$endif}
  function FindFreePiece(const aSize:TAddress; var abstart,abend:TMemBlockIndex):TMemBlockIndex;
  var
    i:TMemBlockIndex;
    runningBlock:boolean;
    blocksNeeded:TMemblockIndex;
    found:boolean;
  begin
    runningBlock:=false;
    blocksNeeded:=(aSize div memoryblocksize)+1;
    {$ifdef sdme}
    WriteHString('blocks needed: '#0);
    WriteHStringLn(IntToShortStr(blocksNeeded));
    {$endif}
    found:=false;
    for i:=0 to bcount do
    begin
      if (GetState_mem(i)=0)and(not runningBlock) then
      begin
        abstart:=i;
        runningBlock:=true;
      end;
      if (GetState_mem(i)<>0)and(RunningBlock) then
      begin
        abend:=i;
        if abend-abstart>=blocksNeeded then
        begin
          found:=true;
          break;
        end;
      end;
    end;
    if found then
    begin
      abend:=abstart+blocksNeeded-1;
      {$ifdef sdme}
        WriteHString('blocks found: '#0);
        WriteHString(IntToShortStr(abstart));
        WriteChar(',');
        WriteHStringLN(IntToShortStr(abend));
      {$endif}
    end;
    if not found then
    begin
      FindFreePiece:=-1;
      exit;
    end;
    FindFreePiece:=blocksNeeded;
  end;
var
  blockStart,blockEnd,count,i:TMemBlockIndex;
begin
  count:=FindFreePiece(_size,blockStart,blockEnd);
  if count=-1 then
  begin
    result:=const_getmemory_err;
    exit;
  end;
//  map[blockStart].count:=count;
  SaveMap(blockStart,1,count);
  for i:=blockStart to blockEnd do SaveMap(i,1,GetCount_mem(i));
  result:=blockStart*memoryblocksize;
  {$ifdef sdme}
    WriteChar('=');
    WriteHStringLN(IntToShortStr(result));
  {$endif}
  {$undef sdme}
end;

function getMemory_absaddr(const _size:Taddress):TAddress;
begin
  result:=GetMemory_reladdr(_size)+const_first_page;
end;

function getMemory(const _size:Taddress):Taddress;
  {$define useabsaddr}
begin
  {$ifdef useabsaddr}
    getMemory:=getMemory_absaddr(_size);
  {$else}
    getmemory:=getMemory_reladdr(_size);
  {$endif}
end;
  {$undef useabsaddr}

function
  FreeMemory_reladdr(const addr:TAddress):boolean;
  {$ifdef hswdbg}
    {$define sdme}
  {$endif}
var
  id,count,i:TMemBlockIndex;
begin
  id:=GetBlockID(addr);
  if GetState_mem(i)=0 then
  begin
    result:=false;
  end
  else
  begin
    id:=FindTrueBlock(addr);
    count:=GetCount_mem(id);
    if count=0 then
    begin
      result:=false;
      exit;
    end;
    for i:=id to id+count-1 do SaveMap(i,0,0);
    SaveMap(id,0,0);
    result:=true;
  end;
  {$undef sdme}
end;

function FreeMemory_absaddr(const addr:TAddress):boolean;
begin
  result:=FreeMemory_reladdr(addr-const_first_page);
end;

function FreeMemory(const addr:TAddress):boolean;
  {$define useabsaddr}
begin
  {$ifdef useabsaddr}
    result:=FreeMemory_absaddr(addr);
  {$else}
    result:=FreeMemory_reladdr(addr);
  {$endif}
end;
  {$undef useabsaddr}

procedure PrintMemoryState;
  procedure WC;
  begin
    WriteChar('(');
    WriteHString(IntToShortStr(bcount));
    WriteChar(')');
  end;
var
  i:TMemBlockIndex;
begin
  {$ifdef writedbg}
  for i:=0 to bcount do
    case map[i].state of
      true: Write('X');
      false: Write('0');
    end;
  WriteLn;
  {$endif}
  {$ifdef hswdbg}
 // WC; <- ЧТО ЭТО ???
  i:=0;
  while i<=bcount do 
  begin
    case GetState_mem(i) of 
      0: WriteChar('0');
      1: WriteChar('X');
    end;
    WriteChar(' ');
    inc(i);
  end;
//  WC; <- ЭТО ТОЖЕ ???
  WriteHstringLn;
  {$endif}
end;

{ tasks functions here (v) }

procedure InitTaskSwitcher(const mmpp:TTaskProcsPack);
begin
  taskf:=mmpp;
end;

procedure ClearTasksRecords; {clear tasks stroages}
var
  i:TTaskIndex;
begin
  for i:=0 to const_maxtasks do
  begin
    tasks[i].currAddr:=const_address_none;
  end;
end;

procedure InitTasks; {prepares task switching}
begin
  ClearTasksRecords;
  activeTask:=const_ActiveTaskNone;
end;

function IsEmptyTask(const atask:TCoolProcess):boolean; inline; {
  checks 'is specified task empty'}
begin
  IsEmptyTask:=(atask.currAddr=const_address_none);
end;

function findEmptyTask:TTaskIndex; inline; {searches for empty task 
  storages}
var
  i,r:TTaskIndex;
begin
  r:=const_findemptytask_err_nofreetasks;
  for i:=0 to const_maxtasks do
  begin
    if IsEmptyTask(tasks[i]) then
    begin
      r:=i;
    end;
  end;
  findEmptyTask:=r;
end;

procedure saveCurrentTaskTo(const t:PCoolProcess); {saves current 
  running task to specified process storage}
begin
  with t^ do
  begin
    t^.currAddr:=taskf.GetJump();
    t^.Registers:=taskf.GetReg();
    t^.stack:=taskf.GetStack();
  end;
end;

procedure saveCurrentTask(const i:TTaskIndex); {то же, 
  что saveCurrentTaskTo}
var
  t:PCoolProcess;
begin
  t:=@tasks[i];
  saveCurrentTaskTo(t);
end;

function RestoreSavedTask(const t:PCoolProcess):boolean; {restores
  process at specified storage to executing}
begin
  if IsEmptyTask(t^) then
  begin
    result:=false;
    exit;
  end;
  with t^ do
  begin
    taskf.SetStack(stack);
    taskf.SetReg(registers);
    result:=taskf.SetJump(currAddr)
  end;
end;

function AddTaskToList(const addr:TAddress):longint; {add specified 
  task to tasks list}
var
  i:TTaskIndex;
begin
  i:=findEmptyTask;
  if i=const_findemptytask_err_nofreetasks then
  begin
    {$ifdef writedbg}
    WriteDebug('error: not enough cell for tasks');
    {$endif}
    AddTaskToList:=const_AddTask_err_nofreetasks;
    exit;
  end;
  tasks[i].currAddr:=addr;
  AddTaskToList:=i;
end;

procedure MakeNomoretaskList; {converts tasks list form
  'X0XX00X000' state to 'XXXX000000' state (i think)}
var
  i,j,last:TTaskIndex;
begin
  last:=0;
  for i:=const_maxTasks downto 0 do
  begin
    if not IsEmptyTask(tasks[i]) then  last:=i;
  end;
  for i:=0 to last do
  begin
    if IsEmptyTask(tasks[i]) then
    begin
      for j:=last-1 downto i do
      begin
        tasks[j]:=tasks[j+1];
      end;
    end;
  end;
end;

function isLastTask(const i:TTaskIndex):boolean; inline; {checks if (is?) specified
  task is last in list}
begin
  result:=(tasks[i].currAddr=const_taskaddr_nomore)or (i>=const_maxtasks);
end;

function SwitchToTask(const idx:TTaskIndex):boolean; {saves current task
  to his storage and restores to running specified task}
begin
  taskf.setrun(false);
  if not (activeTask=const_ActiveTaskNone)
  then
    saveCurrentTask(activeTask);
  result:=RestoreSavedTask(@tasks[idx]);
  taskf.setrun(true);
end;

function LoadTask(const _addr:TAddress;
  const andstart:boolean=false):TTaskIndex;
var
  id:TMemBlockIndex;
  addr:TAddress;
  taskIdx:TTaskIndex;
begin
  if not tasksInited then
  begin
    InitTasks;
  end;
  id:=GetBlockId(_addr);
  if GetState_mem(id)=0 then
  begin
    {$ifdef writedbg}
      WriteDebug('can not LoadTask('+Int2Str(_addr)+') - free block');
    {$endif}
    LoadTask:=const_loadtask_err_notaskhere;
    exit;
  end;
  id:=FindTrueBlock(id);
  addr:=BlockIdToAddr(id);
  taskIdx:=AddTaskToList(addr);
  case taskIdx of
    const_AddTask_err_nofreetasks : begin
      {$ifdef writedbg}
        WriteDebug('err: LoadTask - no free tasks');
      {$endif}
      LoadTask:=const_loadtask_err_notenough;
      exit;
    end;
  end;
  if taskIdx>=0 then
  begin
    {$ifdef writedbg}
      WriteDebug('LoadTask - ok');
    {$endif}
    result:=taskIdx;
  end;

  MakeNomoretaskList;
  
  if andstart then
  begin
    if switchToTask(taskIdx)
    then
    else
      result:=const_loadtask_err_cannotrun;
  end;
end;

function FreeTask(const i:TTaskIndex; const andfreemem:boolean=false):boolean;
begin
  result:=FreeMemory(tasks[i].currAddr);
  if not result then
  begin
    {$ifdef writedbg}
      WriteDebug('Err: Can not freememory for '+Int2Str(i)+' task');
    {$endif}
    exit;
  end;
  tasks[i].currAddr:=const_address_none;
  MakeNomoretaskList;
end;

function findNextTask(const idx:TTaskIndex):TTaskIndex; {returns 
  which task will be next to switch - later there will be used 
  tasks priorityes}
var
  i:TTaskIndex;
begin
  if isEmptyTask(tasks[idx]) then
  begin
    findNExtTask:=idx;
    exit;
  end;
  i:=idx;
  repeat
    inc(i);
    if isLastTask(i) then i:=0;
  until not IsEmptyTask(tasks[i])
end;

function SwitchTask:boolean;
begin
  result:=SwitchToTask(findNextTask(activeTask));
end;

{$endif}

{$ifdef hunit}
end.
{$endif}












