const
  const_OnNewLine=$0D;
  const_OnHomeLine=$0A;

type
  HString_20_byte=array[0..20]of byte;
  Hstring_20_char=array[0..20]of char;
  HString_6_char=array[0..6]of char;
  HString_100_char=array[0..100]of char;
  
procedure WriteChar(const achar:char);
begin
  Write_CHR(ord(achar));
end;

function hIntToStr(const aint:LongWord):Hstring_20_char;
var
  i,n:byte;
  x:LongWord;
begin
  i:=0;
  x:=aint;
  repeat
    x:=x div 10;
    inc(i);
  until x=0;
  n:=i;
  x:=aint;
  for i:=n-1 downto 0 do
  begin
    result[i]:=char((x mod 10)+ord('0'));
    x:=x div 10;
  end;
  result[n]:=#0;
end;

type
  HString_point=array[0..0]of char;
  PHstring=^HString_point;
  
{$ifndef pchar_presents}
  {$define pchar_presents}
  type PChar=^Char;
{$endif}

procedure WriteHString(const s:HString_20_char);
var
  i:byte;
begin
  for i:=0 to 20 do
  begin
    if s[i]=#0 then break;
    writeChar(s[i]);
  end;
end;

procedure WriteHString(const asp:pointer=nil);
var
  s:PHString;
  i:byte;
begin
  if asp=nil then exit;
  s:=asp;
  i:=0;
  repeat
    if s^[i]=#0 then 
    begin
      //WriteChar('.'); //- use this to view real string's end
      break;
    end;
    WriteChar(s^[i]);
    inc(i);
  until false;
end;

procedure WriteHStringLn(const asp:pointer=nil);
  procedure NewLn;
  begin
    //Write_CHR(const_OnNewLine);
    Write_CHR(const_OnHomeLine);
  end;
begin
  if asp<>nil then WriteHString(asp);
  NewLn;
end;

procedure WriteHStringLn(const s:HString_20_char);
begin
  WriteHString(s);
  WriteHstringLN;
end;

procedure WriteChar(const chars:array of char);
var
  i:byte;
begin
  for i:=low(chars) to high(chars) do
  begin
    WriteChar(chars[i]);
  end;
end;

procedure WritePChar(const apchar:PChar);
var
  i:longint;
begin
  i:=0;
  repeat
    WriteChar(apchar[i]);
    inc(i);
  until apchar[i]=#0;
end;

procedure WritePCharLN(const apchar:PChar);
begin
  WritePChar(apchar);
  WriteHStringLN;
end;

  {returns string length without #0}
function HStringLength(const aString:pointer):longint;
var
  s:PHString;
  count:longint;
begin
  HStringLength:=0;
  s:=aString;
  if s=nil then exit;
  count:=0;
  repeat
    if s^[count]=#0 then break;
    count:=count+1;
  until false;
  HStringLength:=count;
end;

function HStringLength(const aString:PChar):longint;
begin
  result:=HStringLength(pointer(aString));
end;

function AddHChar(const aString:pointer; const aChar:char):boolean;
var
  s:PHString;
  i:longint;
begin
  s:=aString;
  if s=nil then
  begin
    exit;
    AddHChar:=false;
  end;
  i:=0;
  repeat
    if s^[i]=#0 then break;
    inc(i);
  until false;
  s^[i]:=aChar;
  s^[i+1]:=#0;
  AddHChar:=true;
end;

function ClearHString(const aString:pointer):boolean;
var
  s:PHString;
begin
  s:=aString;
  if s=nil then
  begin
    ClearHString:=false;
    exit;
  end;
  s[0]:=#0;
  ClearHString:=true;
end;

function InsertHChar(const aString:pointer; const aPos:longint; const aChar:char):boolean;
var
  s:PHString;
  i,l:longint;
begin
  s:=aString;
  if s=nil then
  begin
    InsertHChar:=false;
    exit;
  end;
  l:=HStringLength(s);
  if l+1<aPos then
  begin
    InsertHChar:=false;
    exit;
  end;
  for i:=l+1 downto aPos do
  begin
    s^[i+1]:=s^[i];
  end;
  s^[aPos]:=aChar;
  InsertHChar:=true;
end;

function deleteHChar(const aString:pointer; const aPos:longint):boolean;
var
  s:PHString;
  l,i:longint;
begin
  deleteHChar:=false;
  s:=aString;
  if s=nil then exit;
  l:=HStringLength(s);
  if aPos>=l then exit;
  for i:=aPos to l do
  begin
    s^[i]:=s^[i+1];
  end;
  deleteHChar:=true;
end;

function isEqHStrings(const as1,as2:pointer):boolean;
var
  i:longint;
  r:boolean;
  s1,s2:PHString;
begin
  s1:=as1;
  s2:=as2;
  if (s1=s2) then
  begin
    result:=true;
    exit;
  end;
  if (s1=nil) or (s2=nil) then
  begin
    result:=false;
    exit;
  end;
  if HStringLength(s1)<>HStringLength(s2) then
  begin
    result:=false;
    exit;
  end;
  r:=true;
  i:=0;
  repeat
    if (s1^[i])<>(s2^[i]) then r:=false;
    if (s1^[i]=#0)or(s2^[i]=#0)or(r=false) then break;
    inc(i);
  until false;
  isEqHStrings:=r;
end;

function isEqHStrings(const as1:pointer; const as2:PChar):boolean;
var
  s1:PHString;
  i:longint;
begin
  s1:=as1;
  if HStringLength(s1)<>HStringLength(as2) then
  begin
    result:=false;
    exit;
  end;
  result:=true;
  i:=0;
  repeat
    if s1^[i]<>as2[i] then result:=false;
    if (s1^[i]=#0)or(as2[i]=#0)or(result=false) then break;
    inc(i);
  until false;
end;

function CopyHString(const as1,as2:pointer):boolean;
var
  i:longint;
  s1,s2:PHString;
begin
  CopyHString:=false;
  i:=0;
  s1:=as1;
  s2:=as2;
  repeat
    s2^[i]:=s1^[i];
    if s1^[i]=#0 then break;
    inc(i);
  until false;
  CopyHString:=true;
end;

function trimHString(const aString:pointer):boolean;
const
  const_space=' ';
var
  s:PHString;
  i:longint;
begin
  s:=aString;
  trimHString:=false;
  if s=nil then exit;
  i:=0;
  while s^[i]=const_space do deleteHChar(s,0);
  while s^[hStringLength(s)-1]=const_space do deleteHChar(s,hStringLength(s)-1);
  trimHString:=true;
end;

function hPos(const pString,aString:pointer):longint; //doesnt works!!!
  procedure dw(const s:string);
  begin
    {$ifdef d}
    WriteLN('#hpos: '+s+'#');
    {$endif}
  end;
var
  i,j:longint;
  yes:boolean;
  ast,pst:PHString;
begin
  ast:=aString;
  pst:=pString;
  //dw('started');
  result:=-1;
  (* {$ifdef d} {
  dw('p='+IntToStr(HStringLength(pst))+'; s='+IntToStr(HStringLength(ast)));
  dw('for: '+IntToStr(HStringLength(ast)-HStringLength(pst)));
  } {$endif} *)
  for i:=0 to HStringLength(ast)-HStringLength(pst) do
  begin
    yes:=true;
    j:=0;
    repeat
      if pst^[j]<>ast^[j+i] then
      begin
        yes:=false;
        //dw('symbol #'+IntToStr(i+j)+' - failure');
        break;
      end;
      //dw('symbol #'+IntToStr(i+j)+' - ok');
      inc(j);
    until pst^[j]=#0;
    if yes then
    begin
      //dw('yes.');
      result:=i;
      break;
    end;
  end;
end;

function hPos(const pStr:PChar; const aString:pointer):longint;
begin
  result:=hPos(pointer(pStr),aString);
end;

function hCharPos(const aString:PHString; const aChar:char):longint;
var
  i:longint;
begin
  hCharPos:=-1;
  for i:=0 to HStringLength(aString) do
  begin
    if aChar=aString^[i] then
    begin
      hCharPos:=i;
      break;
    end;
  end;
end;

function CopyHString(const aSource,aDest:PHString; const p1,p2:longint):boolean;
var
  i:longint;
begin
  CopyhString:=false;
  if (aSource=nil)or(aDest=nil) then exit;
  i:=0;
  repeat
    aDest^[i]:=aSource^[i+p1];
    inc(i);
    if aSource^[i]=#0 then break;
    if i>=p2-p1 then break;
  until false;
  aDest^[i+1]:=#0;
  copyHString:=true;
end;

function InsertHString(const aDest,aString:PHString; const aPos:longint):boolean;
var
  i:longint;
  sl,dl:longint;
begin
  InsertHString:=false;
  if (aString=nil)or(aDest=nil) then exit;
  sl:=HStringLength(aString);
  dl:=HStringLength(aDest);
  
  for i:=dl+1 downto aPos do
  begin
    aDest[i+sl]:=aDest[i];
  end;
  
  for i:=aPos to aPos+sl-1 do
  begin
    aDest^[i]:='#';
  end;
  
  //WriteChar('-');
  //WriteHStringLN(aDest);
  
  for i:=aPos to aPos+sl-1 do
  begin
    aDest^[i]:=aString^[i-aPos];
  end;
  InsertHString:=true;
end;

function RightHString(const aSource,aDest:PHString; const acount:longint):boolean;
var
  i:longint;
begin
  RightHstring:=false;
  if (aSource=nil) or (aDest=nil) then exit;
  for i:=0 to acount do
  begin
    aDest[i]:=aSource[HStringLength(aSource)-acount+i];
  end;
  RightHString:=true;
end;

const
  const_hmaxwordsCount=30;
  const_hmaxwordLength=50;

type
  THString_word_char=array[0..const_hmaxwordLength]of char;

  THWords=array[0..const_hmaxwordsCount]of THString_word_char;

function SplitHString(const aString:pointer):boolean;
begin
  SplitHString:=false;
end;















