{  C 
				OS STIMUL
				Dubrovin Alexei aka Abit}

{$I port_io.pas}

{MAJOR.H}
const
	major_ata=5;
{BLKDEV.H}
	max_blkdev=256;
	_write_=0;
	_read_=1;
	_stat_=2;
	ata=1;
	timeout=8192;

type
	blkdev_record=record
		Name 	: String;
		dev_req1:longword;
		dev_req2:byte;
		dev_req3:longword;
		dev_req4:longword;
		dev_req5:byte;
	end;

var
	blkdev:array [0..max_blkdev] of blkdev_record;

{ATA.H}
const
	CH0=$1f0;
	CH1=$1e8;
	CH2=$170;
	CH3=$168;

	BSY=$80;
	DRDY=$40;
	DF=$20;
	DSC=$10;
	DRQ=$08;
	CORR=$04;
	IDX=$02;
	ERR=$01;

	Read_from_Disk=$20;
	Write_to_Disk=$30;

function Get_Dev(X:longWord):byte;
begin
	Get_Dev:=(X and $f00) shr 8;
end;

function Get_Part(X:longWord):byte;
begin
	Get_Part:=(X and $ff);
end;

type
	pt_record=record
	 bootable:byte;
       start_part:array[0..2]of byte;
	type_part:byte;
	 end_part:array[0..2]of byte;
      sect_before:longword;
       sect_total:longword;
	end;

const
	MAX_PART=20;
	PT_SIZE=$10;
	BLK_SIZE=2048;
	BYTE_PER_SECT=512;

type
	dev_status_record=record
		status:byte;
		hd : byte;
		pt:array [1..MAX_PART] of pt_record;
	end;

var
	dev_status:array[1..4]of dev_status_record;

{hdd.c}

const
	channels:array[1..4]of word=(CH0,CH1,CH2,CH3);

type
	ata_request=record
		dev	:byte;
		buff	:array [0..256] of longword; // longWord; //(?)
		nlba	:longWord;
		nsect	:longword;
		err	:byte;
		lock	:byte;
		complite:byte;
	end;

var dev_r:ata_request;

function HD_Busy(dev:byte):word;
const
	t:word=0;
var
	status:byte;
begin
	repeat
		inc(t);
		ReadPortB(status,channels[dev]+7);
		if (t = timeout) then break;
	until not (status = BSY);
	HD_Busy:=t;
end;

function HD_Ready(dev:byte):word;
const
	t:word=0;
var
	status:byte;
begin
	repeat
		inc(t);
		ReadPortB(status,channels[dev]+7);
		if (t = timeout) then break;
	until not (status <> DRDY);
	HD_Ready:=t;
end;

function HD_Data_Request(dev:byte):boolean;
var status:byte;
begin
	ReadPortB(status,channels[dev]+7);
	HD_Data_Request:=(status = DRQ);
end;

function Check_Error(dev:byte):boolean;
var a:byte;
begin
	ReadPortB(a,channels[dev]+7);
	Check_Error:=(a = ERR);
end;

function Get_ATA_Identity(dev:byte):byte;
var i:word; mr1,mr2:word; res:byte;
begin
	res:=0;
	if (hd_busy(dev) = TIMEOUT) then res:=$ff
	else
	begin
		if ((dev=0)or(dev=2)) then
			WritePortB($e0,channels[dev]+6)
		else
		if ((dev=1)or(dev=3)) then
			WritePortB($f0,channels[dev]+6);

		if (hd_ready(dev)=timeout) then res:=$ff
		else WritePortB($ec,channels[dev]+7);
	end;
	if res<>$ff then
	begin
		if check_error(dev) then res:=$ff
		else
		begin
			for i:=0 to TimeOut do 
				if hd_data_request(dev) then break;
			if (i=TimeOut) then res:=$ff;
		end;
	end;

	if res<>$ff then
	begin
		mr1:=dev_status[dev].hd;
		mr2:=channels[dev];
	asm
		mov	dx,mr1
		mov	ax,mr2
		mov	cx,$100
		cld
	@L:	in	ax,dx
		stosw
		dec	cx
		jnz @L
	end;
	Get_ATA_Identity:=res;
	end;
end;

Procedure Get_ATA_Info;
var
	dev:byte;
begin
	for dev:=1 to 4 do 
	begin
		if (hd_busy(dev)=(TimeOut)) then 
			begin
			   dev_status[dev].status:=0;
			   continue;
			end;
		dev_status[dev].status:=0;
		if (Get_ATA_identity(dev)=$ff) then dev_status[dev].status:=0;
	end;
end;



Function Send_Command(cmd:Byte):boolean;
begin
	if (hd_busy(dev_r.dev)=(TimeOut)) then Send_Command:=False
	else
	begin
		if ((dev_r.dev=0)or(dev_r.dev=2)) then
			WritePortB((((dev_r.nlba and $f000000)shr 24)or $e),
					channels[dev_r.dev]+6)
		else if ((dev_r.dev=1)or(dev_r.dev=3)) then
			WritePortB((((dev_r.nlba and $f000000)shr 24)or $f),
					channels[dev_r.dev]+6);

		hd_ready(dev_r.dev);

		WritePortB(dev_r.nsect,channels[dev_r.dev]+2);
		WritePortB((dev_r.nlba and $ff),channels[dev_r.dev]+3);
		WritePortB(((dev_r.nlba and $ff00)shr 8),channels[dev_r.dev]+4);
		WritePortB(((dev_r.nlba and $ff0000)shr 16),channels[dev_r.dev]+5);

		WritePortB(cmd,channels[dev_r.dev]+7);
		Send_Command:=True;
	end;
end;

Procedure Intr_Read;
var i:word;
begin
	dev_r.complite:=0;
	hd_busy(channels[dev_r.dev]);
	if check_error(channels[dev_r.dev]) then dev_r.err:=1
	else
	begin
		while (not(HD_Data_Request(dev_r.dev))) do continue;
		for i:=0 to $ff do ReadPortW(dev_r.buff[i],channels[dev_r.dev]);
		dev_r.complite:=1;
	end;
end;

Procedure Intr_Write;
var i:word;
begin
	dev_r.complite:=0;
	hd_busy(channels[dev_r.dev]);
	if check_error(channels[dev_r.dev]) then dev_r.err:=1
	else
	begin
		while (not(HD_Data_Request(dev_r.dev))) do continue;
		for i:=0 to $ff do WritePortW(dev_r.buff[i],channels[dev_r.dev]);
		dev_r.complite:=1;
	end;
end;