const
  const_fssMaxLength=64-1;

{$define TFSSL:=TFixedShortStrList}

type
  TFixedShortStrList=record
    items:array [0..const_fssMaxLength] of TShortString;
    len:int;
  end;

  TFSSLForeachFunc=function(const s:TShortString):boolean;

procedure tfssl_clear(var alist:TFSSL);
var
  i:int;
begin
  alist.len:=0;
  i:=0;
  while i<const_fssMaxLength do
  begin
    alist.items[i].len:=0;
    inc(i);
  end;
end;

function tfssl_add(var al:TFSSL; const astr:TShortString):boolean;
begin
  result:=al.len+1<const_fssMaxLength;
  if not result then exit(false);
  al.len+=1;
  al.items[al.len-1]:=astr;
end;

function tfssl_foreach(const al:TFSSL; const aProc:TFsslForeachFunc):boolean;
var
  i:int;
begin
  i:=0;
  result:=false;
  while i<al.len do
  begin
    if not aProc(al.items[i]) then break;
    inc(i);
  end;
  result:=true;
end;

function tfssl_get(const al:TFSSL; const aidx:int):TShortString;
begin
  if not ((0<=aidx)and(aidx<al.len)) then exit(sstr_create(nil));
  result:=al.items[aidx];
end;

{$undef tfssl}
