// "smconsole.pas"

// System mode console by hinst; year=2009

const
  const_smc_maxCommandLineParams=45;
  
  {$defne macro_mcparams:=const_smc_maxCommandLineParams}
  {$define macro_scp:=smConsoleProcs}
  {$define scp:=macro_scp}
  {$define scv:=smConsoleVars}

  const_smc_consoleSymbols:string='!@#$%^&*()_+/\|[]{}= !1234567890'#0;

type
  
  TsmcExecVar=TFixedShortStrList;
  
  TsmcOnNextStrProc=function(const s:TShortString):shortint;
  TsmcOnExecProc=function(const aexvar:TsmcExecVar):shortint;
  
  TsmConsoleProcs=record
    DoNextString:TsmcOnNextStrProc;
    DoExec:TsmcOnExecProc;
  end;
  
  TsmConsoleVars=record
    currst,prest:tshortString; 
    constate:byte;
    curch:byte;
  end;

  TsmConsoleKey=record
    letter:char; //dl
    subchar:char; //cl
    bchar:char; //bl
    achar:char; //al
  end;

  
const
  const_smc_StateRunning=2;
  const_smc_StateInitialized=1;
  const_smc_StateBusy=3;
  const_smc_StateExiting=4;

const
  const_smc_defaultTextAttr=$0F;
  const_smc_defaultCurAttr=$2F;

  const_smc_screenWidth=80;
  const_smc_screenheight=24;

{ key const }
const
  const_smckey_enterdown=28;
  const_smckey_enterup=156;

  const_smckey_backspaceDown=14;
  const_smckey_backspaceUp=142;

  const_smckey_leftDown=75;
  const_smckey_leftUp=203;
  const_smckey_RightDown=77;
  const_smckey_RightUp=205;

  const_smckey_deleteDown=83;
  const_smckey_deleteUp=211;

  const_smckey_HomeDown=71;
  const_smckey_EndDown=79;
{/key const }
  
var
  smConsoleProcs:TsmConsoleProcs;
  smConsoleVars:TsmConsoleVars;
  
{$i convideo_util.pas}

  {wrn: "Do*"s must be assinged}
function smc_Initialize(const acp:TsmConsoleProcs):boolean;
begin
  scp:=acp;
  scv.currst:=sstr_create(nil);
  scv.prest:=sstr_create(nil);

  scv.constate:=const_smc_StateInitialized;
  scv.curch:=1;
  smvu_ClearOnNewLine:=true;
  result:=true;
end;

procedure smc_text_default;
begin
  smvu_caret.color:=const_smc_defaultTextAttr
end;

procedure smc_text_color(const aclr:byte);
begin
  smvu_caret.color:=aclr;
end;

function smc_ClearScreen:boolean;
begin
  smvu_clear;
end;

function smc_GetKeyChar:TsmConsoleKey;
var
  lttr:char;
  sbch:char;
  a,b:char;
begin
  asm
    mov ah, 1
    int 22h
    mov lttr, dl
    mov sbch, cl
    mov b,bl
    mov a,al
  end;
  result.letter:=lttr;
  result.subchar:=sbch;
  result.achar:=a;
  result.bchar:=b;
end;

function smc_OnChar(const aky:TsmConsoleKey):boolean; forward;
function smc_OnEnter:boolean; forward;
function smc_RefreshScreenStr(const aCursorNeeded:boolean=true):boolean; forward;

const
  const_conmes_emp:string='empty str entered'#0;
  const_conmes_1:string=' requested with '#0;
  const_conmes_2:string=' params'#0;

function smc_processString(const astr:TShortString):boolean;
var
  ps:TsmcExecVar; //"ps"=params
  i:longint;
  msg:TShortString;
begin
  smc_text_default;
  sstr_split(astr,' ',ps);
  if ps.len=0 then sstr_echoPchLn(@const_conmes_emp);
  smvu_write('*');
  msg:=sstr_create(@const_conmes_1);
  msg:='"'+ps.items[0]+'"'+msg+IntToShortStr(ps.len-1)+@const_conmes_2;
  smvu_writeLn(msg);
  i:=1;
  while i<ps.len do
  begin
    smvu_writeLn(IntToShortStr(i)+'='+ps.items[i]);
    inc(i);
  end;
end;

function smc_WaitForStr:TShortString;
var
  k:TsmConsoleKey;
begin
  while true do
  begin
    k:=smc_GetKeyChar;
    if ord(k.achar)=const_smckey_enterDown then break;
    smc_OnChar(k);
  end;
  result:=scv.currst;
  smc_OnEnter;
  smvu_typenter;
end;

function smc_RunConsole:boolean;
var
  ky:TsmConsoleKey;
begin
  scv.constate:=const_smc_StateRunning;
  //TestScrolling;
  smvu_clear;
  repeat
    smc_WaitForStr;
    smc_ProcessString(scv.currst);
    sstr_clear(scv.currst);
  until scv.constate=const_smc_StateExiting;
  result:=true;
end;

function smc_IsSymbol(const ach:char):boolean;
begin
  result:=sstr_isLetter(ach) or (sstr_pos(ach,@const_smc_consoleSymbols)>0);
end;

function smc_InitAndRun(const acp:TsmConsoleProcs):boolean;
begin
  result:=smc_Initialize(acp);
  if not result then exit;
  result:=smc_RunConsole;
end;

function smc_OnSymbol(const ach:char):boolean;  
const 
  s_gotsmb:string='gotsmb: '#0;
begin
  sstr_insertChar(scv.currst,scv.curch,ach);
  inc(scv.curch);
end;

procedure smc_echoThestring(const s:TShortString);
var
  i:longint;
  t:byte;
begin
  i:=1;
  while i<=s.len do
  begin
    case i=scv.curch of
      false: smvu_write(s.st[i]);
      true:
      begin
        smvu_caret.color:=const_smc_defaultCurAttr;
        smvu_write(s.st[i]);
        smvu_caret.color:=const_smc_defaultTextAttr;
      end;
    end;
    inc(i);
  end;
  if scv.curch=s.len+1 then
  begin
    smvu_caret.color:=const_smc_defaultCurAttr;
    smvu_write(' ');
    smvu_caret.color:=const_smc_defaulttextAttr;
  end;
end;

function smc_RefreshScreenStr(const aCursorNeeded:boolean=true):boolean;
const
  s_typendd:string='<emptytext>'#0;
var 
  curry:byte;
begin
  curry:=smvu_caret.y;
  smvu_scrollvalue:=@curry;
  smvu_backline;
  smvu_ClearLine;
  smvu_StateStr:=IntToShortStr(smvu_caret.y);
  smvu_write(scv.prest);
  smc_text_default;
  case aCursorNeeded of
    true:
    case sstr_length(scv.currst)=0 of
      true: smc_echoThestring(sstr_create(@s_typendd));
      false: smc_EchoThestring(scv.currst);
    end;
    false:
    begin
      smvu_write(scv.currst);
    end;
  end;
  smvu_refresh;
  smvu_backline(curry);
  smvu_scrollvalue:=nil;
  result:=true;
end;

function smc_OnEnter:boolean;
const 
  s_enterPressed:string[36]='<enter pressed... please, wait>'#0;
begin
  scv.curch:=1;
  smc_RefreshScreenStr(false);
end;

procedure smc_CheckCurPos;
begin
  with scv do
  begin
    if curch<1 then curch:=1;
    if curch>currst.len+1 then curch:=currst.len+1;
  end;
end;

function smc_OnBackspacePressed:boolean;
begin
  result:=sstr_DeleteSymbol(scv.currst,scv.curch-1);
  if result then dec(scv.curch);
  smc_CheckCurPos;
end;

function smc_OnDeletePressed:boolean;
begin
  result:=sstr_deleteSymbol(scv.currst,scv.curch);
  smc_CheckCurPos;
end;

function smc_OnLeftRightPressed(const aleft:boolean):boolean;
begin
  case aleft of
    true: dec(scv.curch);
    false: inc(scv.curch);
  end;
  smc_CheckCurPos;
end;

procedure smc_OnHomeEndPressed(const aHome:boolean);
begin
  case ahome of
    true: scv.curch:=1;
    false: scv.curch:=scv.currst.len+1;
  end;
end;

function smc_OnHotKey(const ach:char):boolean;
const
  s_gotkey:string='got key: '#0;
var
  c:byte;
begin
  c:=byte(ach);
  result:=true;
  case c of
    const_smckey_enterDown: smc_OnEnter;
    const_smckey_backspaceDown: smc_OnBackspacePressed;
    const_smckey_deleteDown: smc_OnDeletePressed;
    const_smckey_leftDown: smc_OnLeftRightPressed(true);
    const_smckey_rightDown: smc_OnLeftRightPressed(false);
    const_smckey_HomeDown: smc_OnHomeEndPressed(true);
    const_smckey_EndDown: smc_OnHomeEndPressed(false);
    else result:=false;
  end;
end;

function smc_OnChar(const aky:TsmConsoleKey):boolean;
  procedure echo_dmsg;
  var
    s:TShortString;
    cpos:word;
  begin
    s.len:=0;
    //s:='|'+IntToShortStr(ord(aky.letter)); //noneed
    s:=s+'|'+IntToShortStr(ord(aky.achar))+'a'; //hotkeys
    s:=s+'|'+IntToShortStr(scv.curch)+'@';
    s:=s+'|'+IntToShortStr(ord(aky.subchar))+'c';
    if not smc_IsSymbol(aky.letter) then s:=s+'*';
  end;
begin
  case smc_IsSymbol(aky.letter) of
    true: result:=smc_OnSymbol(aky.letter);
    false: result:=smc_OnHotKey(aky.achar); //??
  end;
  smc_text_default;
  smc_RefreshScreenStr;
end;

  
{$undef macro_mcparams}
{$undef macro_scp}
{$undef scp}
{$undef scv}
