{Stringman.pas}

const
  const_ShortStringLength=255;
  
  const_OnNewLine=$0D;
  const_OnHomeLine=$0A;

{$MACRO ON}

{$define macro_msl:=const_ShortStringLength}
{$define int:=longint}

{define testmode}
{$define overloado}
{$define oldfuncs}

type
  TShortString=record
    st:array[1..const_ShortStringLength] of char;
    len:int;
  end;

  PShortString=^TShortString;
 
  PsstrChar=^char;
 
function sstr_length(const s:TShortString):int; 
begin
  result:=s.len;
end;

function sstr_ConvPcharPoint(c:PsstrChar):PsstrChar;
var
  i,j:byte; 
  p,rd,g:pointer;
begin
  rd:=@r;
  g:=c;
  asm
    mov eax,dword ptr [$20001]
    add eax,g
    sub eax,rd
    mov p,eax
  end;
  result:=p;
end;

function sstr_create(const apch:PsstrChar):TShortString;
var
  i:int;
  s:TShortString;
  p:PsstrChar;
begin
  if apch=nil then
  begin
    s.len:=0;
    exit(s);
  end;
  p:=sstr_ConvPcharPoint(apch);
  i:=0;
  while i<=macro_msl do
  begin
    inc(i); 
    s.st[i]:=p[i-1];
    if p[i]=#0 then break;
  end;
  s.len:=i;
  result:=s;
end;

procedure WriteChar(const achar:char); forward;

procedure sstr_clear(var astr:TShortString);
begin
  astr.len:=0;
end;

function sstr_create(const ach:char; const at:int):TShortString;
var
  i:int;
begin
  result.len:=at;
  for i:=1 to at do result.st[i]:=ach;
end;
  
function sstr_IsLetter(const ach:char):boolean;
begin
  result:=('a'<=ach)and(ach<='z') or ('A'<=ach)and(ach<='Z');
end;

function sstr_pos(const aWhat:char; const aWhere:TShortString):int;
var
  i:int;
begin
  result:=0;
  i:=1 ;
  repeat 
    if aWhat=aWhere.st[i] then exit(i);
    inc(i);
  until i>=sstr_length(aWhere);
end;

function sstr_pos(const aWhat:char; const aWhere:PsstrChar):int;
var
  i:int;
  pWhere:PsstrChar;
begin
  result:=0;
  pWhere:=sstr_convPcharPoint(aWhere);
  i:=0;
  repeat
    if pWhere[i]=aWhat then exit(i);
    inc(i);
  until pWhere[i]=#0;
end;

procedure sstr_newLn;
begin
  Write_CHR(const_OnHomeLine);
end;

function sstr_echo(const astr:TShortString):boolean;
var
  i:int;
begin
  if astr.len=0 then exit(true);
  i:=1;
  while i<=sstr_length(astr) do
  begin
    Write_CHR(byte(astr.st[i]));
    inc(i);
  end;
  result:=true;
end;

function sstr_echoPch(const astr:PsstrChar):boolean;
begin
  Write_CString(astr);
end;

function sstr_echoReal(const astr:PChar):boolean;
var
  i:int;
begin
  i:=0;
  while astr[i]<>#0 do
  begin
    Write_CHR(byte(astr[i]));
    inc(i);
  end;
  result:=true;
end;

function sstr_echoLn(const astr:TShortString):boolean;
begin
  result:=sstr_echo(astr);
  sstr_newLn;
end;

function sstr_echoPchLn(const astr:PsstrChar):boolean; inline;
begin
  result:=sstr_echoPch(astr);
  sstr_NewLn;
end;


{ TFixedString }

type
  TFixedString=object
  private
    thes:TShortString;
    function getsymbol(const aidx:int):char;
  public
    property symbols[const i:int]:char read getsymbol; default;
  end;

function TFixedString.getsymbol(const aidx:int):char;
begin
  result:=thes.st[aidx];
end;

{/TFixedString }


function sstr_concat(const as1,as2:TShortString):TShortString;
var
  i:int;
  s:TShortString;
  st1,st2:^char;
begin
  s.len:=0;
  if sstr_length(as1)+sstr_length(as2)>macro_msl then exit(s);

  s.len:=sstr_length(as1)+sstr_length(as2);

  i:=1; repeat
    s.st[i]:=as1.st[i];
    inc(i);
  until i>sstr_length(as1);

  i:=1; repeat
    s.st[i+sstr_length(as1)]:=as2.st[i];
    inc(i);
  until i>sstr_length(as2);

  result:=s;
end;

function sstr_AddPcharConst_nocon(var s:TShortString; const apch:PsstrChar):boolean;
var
  p:^char;
begin
  {
  sstr_NewLn;
  Write_CHR(ord('A'));
  }
  p:=apch;
  if p=nil then exit(false);
  while p^<>#0 do
  begin
    inc(s.len);
    s.st[s.len]:=p^;
    inc(p);
  end;
end;

function sstr_AddPcharConst(var s:TShortString; const apch:PsstrChar):boolean;
var
  p:^char;
begin
  p:=sstr_ConvPcharPoint(apch);
  sstr_AddPcharConst_nocon(s,p);    
end;

function IntToShortStr(const aint:int):TShortString;
var
  x,i:int;
  s:TShortString;
begin
  if aint=0 then
  begin
    s.len:=1;
    s.st[1]:='0';
    exit(s);
  end;
  x:=aint;
  s.len:=0;
  repeat
    inc(s.len);
    x:=x div 10;
  until x=0;
  x:=aint;
  i:=s.len;
  repeat
    s.st[i]:=char(x mod 10+ord('0'));
    x:=x div 10;
    dec(i);
  until i<1;
  result:=s;
end;

function sstr_AddChar(var astr:TShortString; const ach:char):boolean;
{var p:^Byte; len:longword; cb:byte;}
begin
  if sstr_length(astr)>=macro_msl then exit(false);
  inc(astr.len);
  
  astr.st[sstr_length(astr)]:=ach;
  {
  p:=Pointer(sstr_ConvPcharPoint(Pointer(@astr.st)));
  len:=astr.len-1;
  cb:=ord(ach);
  asm
	mov	eax,len
	add	eax,p
	xor	ebx,ebx
	mov	bl,cb
	mov	byte ptr[eax],bl
  end;
  result:=true;
  }
end;

function sstr_copy(const astr:TShortString; const afrom,ato:int):TShortString;
var
  i:int;
begin
  result.len:=0;
  if afrom<1 then exit; 
  if ato>sstr_length(astr) then exit;
  result.len:=ato-afrom+1;
  if result.len<0 then 
  begin
    result.len:=0;
    exit;
  end;
  i:=afrom;
  repeat
    result.st[i-afrom+1]:=astr.st[i];
    inc(i);
  until i>ato;
end;

function sstr_insertChar(var s:TShortString; const aidx:int; const achar:char):boolean;
var
  i:int;
begin
  result:=(0<aidx)and(aidx<=s.len+1)and(s.len<macro_msl);
  if not result then exit;
  inc(s.len);
  i:=s.len;
  while aidx<i do
  begin
    s.st[i]:=s.st[i-1];
    dec(i);
  end;
  s.st[aidx]:=achar;
  result:=true;
end;

function sstr_DeleteSymbol(var s:TShortString; const aidx:int):boolean;
var
  i:int;
begin
  result:=(0<aidx)and(aidx<=s.len)and(s.len<macro_msl);
  if not result then exit;
  i:=aidx;
  while i<s.len do
  begin
    s.st[i]:=s.st[i+1];
    inc(i);
  end;
  dec(s.len);
end;

function sstr_copy(const astr:PsstrChar; const afrom,ato:int):TShortString;
begin
  result:=sstr_copy(sstr_create(astr),afrom,ato);
end;

function sstr_CharPos(const astr:TShortString; const aChar:char):int;
var
  i:int;
begin
  i:=1;
  while i<=astr.len do
  begin
    if astr.st[i]=aChar then exit(i);
    inc(i);
  end;
  result:=0;
end;

procedure sstr_Delete(var s:TShortString; const aFrom,aTo:int);
var
  i:int;
  ss:TShortString;
  from,tto:int;
begin
  if s.len=0 then exit;
  from:=aFrom;
  tto:=aTo;
  if from<1 then from:=1;
  if tto>s.len then tto:=s.len;
  i:=1;
  ss.len:=0; 
  while (i<=s.len) do
  begin
    if not((from<=i)and(i<=tto)) then
    begin
      inc(ss.len);
      ss.st[ss.len]:=s.st[i];
    end;
    inc(i);
  end;
  s:=ss;
end;

{$i mad_strlist.inc.pas}

procedure sstr_split(const astr:TShortString; const aChar:char;
  var al:TFixedShortStrList);
  procedure wdo(const aw:TShortString);
  begin
    tfssl_add(al,aw);
  end;
var
  i:int;
  w:TShortString;
begin
  w.len:=0;
  i:=1;
  tfssl_clear(al);
  while i<=astr.len do
  begin
    case astr.st[i]=aChar of
      true: 
      begin 
        if w.len>0 then
	begin
          wdo(w);
	  w.len:=0;
	end;
      end;
      false: begin
        inc(w.len);
	w.st[w.len]:=astr.st[i];
      end;
    end;
    inc(i);
  end;  
  if w.len>0 then wdo(w);
end;


{$ifdef overloado}

operator + (const as1,as2:TShortString) r:TShortString;
begin
  r:=sstr_concat(as1,as2);
end;

operator + (const as1:TShortString; const as2:PsstrChar) r:TShortString;
begin
  r:=sstr_concat(as1,sstr_create(as2));
end;

operator + (const as1:PsstrChar; const as2:TShortString) r:TShortString;
begin
  r:=sstr_concat(sstr_create(as1),as2);
end;

operator + (const as1:char; const as2:TShortstring) r:TShortString;
begin
  r:=as2;
  sstr_InsertChar(r,1,as1);
end;

operator + (const as1:TShortString; const as2:char) r:TSHortString;
begin
  r:=as1;
  sstr_AddChar(r,as2);
end;

{$endif}


{$ifdef oldfuncs}
//support old functionnames

procedure WriteChar(const achar:char);
begin
  Write_CHR(ord(achar));
end;

function WriteHString(const astr:TShortString):boolean;
begin
  result:=sstr_echo(astr);
end;

function WriteHString(const astr:PsstrChar):boolean;
begin
  result:=sstr_echoPch(astr);
end;

function WriteHStringLn(const astr:TShortString):boolean;
begin
  result:=sstr_echo(astr);
  sstr_newLn;
end;

function WriteHStringLN(const astr:PsstrChar):boolean;
begin
  result:=WriteHString(astr);
  sstr_newLn;
end;

procedure WriteHStringLN;
begin
  sstr_newLn;
end;

{$endif}

 
{$undef macro_msl}
{$undef int}

{$undef testmode}
{$undef overloado}

{end}
