program test_hmutexes;

{hcode}

{$mode objfpc}

uses Types, Classes, SysUtils;


type
  TAddress=longint;
{$define hall}
  {$I hmutex.inc.pas}
{$undef hall}

procedure PrintMutexesState;
var
  i,j,last:integer;
begin
  last:=0;
  for i:=1 to GetMutexesCount do
  begin
    for j:=last to const_maxmut do
    begin
      if not isEmptyMutex(mutexes(j)^) then
      begin
        Write(mutexes(j)^.mutobj);
        case mutexes(j)^.wholds=0 of
          true:
            Write('_');
          false:
            Write('*');
        end;
        last:=j+1;
        break;
      end;
    end;
  end;
  WriteLN;
end;

type
  TSampleObject=class(TComponent)
  private
    ihold:array[0..4]of TMutexIdx;
  public
    procedure HoldSomeMutexes(const aCount:longint);
    procedure FreeSomeMutex;
    procedure FreeAllMutexes;
  end;
  
var
  objs:array[0..3] of TSampleObject;

procedure TSampleObject.HoldSomeMutexes(const aCount:longint);
var
  i,c:integer;
begin
  c:=0;
  i:=0;
  repeat
    if (isFreeMutex(mutexes(i)^)and(random(3)=2)) then
    begin
      Write('YES.');
      case GivemeMutex(i, integer(self))>0 of
        true:
        begin
          inc(c);
          ihold[i]:=0;
          WriteLn('Mutex getted (',i,')');
        end;
        false:
        begin
          WriteLN('Err while getting mutex');
        end;
      end;
    end;
    if c>=aCount then break;
    inc(i);
    if i>=const_maxmut then i:=0;
  until false;
end;

procedure TSampleObject.FreeSomeMutex;
var
  i:integer;
begin
  i:=random(length(ihold));
  ReleaseMutex(ihold[i],longint(self));
end;

procedure TSampleObject.FreeAllMutexes;
begin
  WriteLN('Mutexes released: ', ReleaseMyMutexes(longint(self)));
end;

var
  i:integer;

begin
  WriteLN('   ***TEST APP FOR HMUTEXES***   ');
  randomize;
  objs[1]:=TSampleObject.Create(nil);
  objs[2]:=TSampleObject.Create(nil);
  objs[3]:=TSampleObject.Create(nil);
  WriteLN('Objs created.');
  
  for i:=0 to 9 do CreateMutex(i);
  WriteLn('count = ',GetMutexesCount);
  WriteLN('Some mutexes created.');
  objs[1].HoldSomeMutexes(4);
  WriteLN('Some mutexes hold.');
  PrintMutexesState;
  
  for i:=10 to 19 do CreateMutex(i);
  objs[2].HoldSomeMutexes(5);
  WriteLn(GetMutexesCount);
  PrintMutexesState;
  
  for i:=20 to 29 do CreateMutex(i);
  objs[3].HoldSomeMutexes(6);
  WriteLn(GetMutexesCount);
  PrintMutexesState;
  
  objs[1].FreeSomeMutex;
  objs[2].FreeSomeMutex;
  objs[3].FreeSomeMutex;
  WriteLn(GetMutexesCount);
  PrintMutexesState;
  
  objs[1].FreeAllMutexes;
  PrintMutexesState;
  objs[2].FreeAllMutexes;
  PrintMutexesState;
  objs[3].FreeAllMutexes;
  PrintMutexesState;
  WriteLn(GetMutexesCount);
end.
